// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// LetterView.cpp : implementation file
//

#include "stdafx.h"
#include "hermes gui.h"
#include "LetterView.h"
#include "TGenericException.h"
#include "TPostOffice.h"
#include "TLetter.h"
#include "TFolder.h"
#include "Hermes GUIDoc.h" 
#include "ViewSource.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CLetterView

IMPLEMENT_DYNCREATE(CLetterView, CFormView)

CLetterView::CLetterView()
	: CFormView(CLetterView::IDD)
{
	//{{AFX_DATA_INIT(CLetterView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CLetterView::~CLetterView()
{
}

void CLetterView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLetterView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

CString ConvertString(CString str)
{
	CString res;

	for(int i =0; i < str.GetLength();i++)
	{
		if(str[i] == '\n')
		{	
			res+= "\r\n";
		}
		else
			res+= str[i];
	}
	return res;
}

void CLetterView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint )
{
	CHermesGUIDoc *doc = (CHermesGUIDoc *) GetDocument();

	TLetter* letter = doc->letter;

	if(letter) // There really is a letter to view
	{
		THeader* header = &letter->GetHeader();

		POSITION pos = header->GetTo().GetHeadPosition();
		CString ToField("");
		CString CCField("");
		TAddress *toadr, *ccadr;
		while( !(pos == NULL) )
		{
			toadr =header->GetTo().GetNext(pos);
			if(ToField.GetLength() > 0)
				ToField += ", ";
			ToField += toadr->GetName() + CString(" <") + toadr->GetAddress() + CString(">");
		}
		
		SetText(ToField, IDC_LETTERTOFIELD);

		pos = header->GetCC().GetHeadPosition();
		while( !(pos == NULL) )
		{
			ccadr =header->GetCC().GetNext(pos);
			if(CCField.GetLength() > 0)
				CCField += ", ";
			CCField += ccadr->GetName() + CString(" <") + ccadr->GetAddress() + CString(">");
		}
		
		SetText(CCField, IDC_LETTERCCFIELD);
		
		TAddress fromadr = header->GetFrom();


		SetText(fromadr.GetName() + 
			CString(" <") + 
			fromadr.GetAddress() + 
			CString(">")
			, IDC_LETTERFROMFIELD);
		SetText(header->GetSubject(), IDC_LETTERSUBJECTFIELD);
		SetText(header->GetDate(), IDC_LETTERDATEFIELD);


		// Convertstring returns newed string that we have to delete 
		// when finished.
		CString* str = &letter->GetReadableText();

		
		SetText(ConvertString(*str), IDC_LETTERBODYFIELD);
		delete str;
	}
	else
	{
		SetText("", IDC_LETTERTOFIELD);
		SetText("", IDC_LETTERCCFIELD);
		SetText("", IDC_LETTERFROMFIELD);
		SetText("", IDC_LETTERSUBJECTFIELD);
		SetText("", IDC_LETTERDATEFIELD);
		SetText("", IDC_LETTERBODYFIELD);
	}
	CFormView::OnUpdate(pSender, lHint, pHint );
}



void CLetterView::SetText(const CString str, UINT nID)
{
	CStatic* sctrl = (CStatic *) GetDlgItem(nID);

	if(!sctrl)
		EXCEPT("Could not obtain dlg object!");

	sctrl->SetWindowText(str);
}



BEGIN_MESSAGE_MAP(CLetterView, CFormView)
	//{{AFX_MSG_MAP(CLetterView)
	ON_EN_UPDATE(IDC_LETTERBODYFIELD, OnUpdateLetterbodyfield)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_VIEWSOURCE, OnViewsource)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLetterView diagnostics

#ifdef _DEBUG
void CLetterView::AssertValid() const
{
	CFormView::AssertValid();
}

void CLetterView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG



/////////////////////////////////////////////////////////////////////////////
// CLetterView message handlers




void CLetterView::OnUpdateLetterbodyfield() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CFormView::OnInitDialog()
	// function to send the EM_SETEVENTMASK message to the control
	// with the ENM_UPDATE flag ORed into the lParam mask.
	
	// TODO: Add your control notification handler code here
	CStatic* sctrl = (CStatic *) GetDlgItem(IDC_LETTERBODYFIELD);

	if(!sctrl)
		EXCEPT("Could not obtain dlg object!");
	CString str;
	sctrl->GetWindowText(str);
}

void CLetterView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);
	
	CEdit* ctr = (CEdit *) GetDlgItem(IDC_LETTERBODYFIELD);	

	// If the control hasn't yet been created a null pointer is returned
	if(ctr != NULL)
		ctr->SetWindowPos(NULL, 0, 0, 
			cx-30,  cy-100, SWP_NOMOVE | SWP_NOZORDER);

}

void CLetterView::OnViewsource() 
{
	// The user has pressed the view source button.
	CHermesGUIDoc *doc = (CHermesGUIDoc *) GetDocument();
	
	if(doc->letter)
	{
		CViewSource sourcedlg(ConvertString(doc->letter->GetRawData().GetString()));

		sourcedlg.DoModal();
	}

}
