// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// $Header: /Hermes GUI/TRawData.cpp 12    97-11-30 11:49 Fcl $
// $Log: /Hermes GUI/TRawData.cpp $
//
//12    97-11-30 11:49 Fcl
//Added a view source vindow in the letterview
//
//11    97-11-28 23:38 Fcl
//Added cut&paste support in header window
//Added copy constructors when needed,
//
//10    97-11-26 13:04 Peblin
//fixed precompiled headers
//
//9     97-11-25 20:59 Fcl
//Changed the decoding of the header
//
//8     97-11-23 13:27 Peblin
//Added CSocket support
//
//7     97-11-15 21:40 Fcl
//First tested version. Is able to save and load folders with no letters
//inside
//
//6     97-11-14 17:58 Fcl
//
//5     11/12/97 11:04 Magnus
//All functionallity implemented. Compiles
//
//4     97-11-06 21:59 Fcl
//Added Header and Log statements at the top of each file

// TRawData.cpp: implementation of the TRawData class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "TRawData.h"
#include "TGenericException.h"
#include <afx.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TRawData::TRawData(CString& s)
{
	mem = new char[s.GetLength()];
	strcpy(mem,s);

	mmap = NULL;
	size = s.GetLength();

	// The marks below are not valid any more
	// The conversion from Cstring* to char* (mem) could not 
	// be accomplished without a const declaration on mem. 
}

TRawData::~TRawData()
{
	if (mmap == NULL)
	{
		// Delete Rawdata from primary mem
		// delete const_cast<char *>(mem);
		delete mem;
	}
	else
	{
		// Delete MMap object
		delete mmap;
	}
}

TRawData::TRawData(TMMap* m)
{
	mmap = m;
	mem = mmap->GetPointer();
	size = mmap->GetSize();
}

int TRawData::GetSize()
{
	// Return length of RawData file or RawData string.
	return size;
}

char* TRawData::GetMem()
{
	// Returns pointer to RawData string.
	return mem;
}

CString TRawData::GetString()
{
	// Extract the rawdata as a CString
	CString res;
	for(int i = 0; i < GetSize();i++)
		res += GetMem()[i];
	
	return res;
}

void TRawData::ReleaseFile()
{
	// Is the data on disk?
	if(mmap)
	{
		// Allocate  new memory for data
		mem = new char[GetSize()];

		// Copy the data disk -> memory
		memcpy(mem, mmap->GetPointer(), GetSize());

		//Remove the mmap (which releases the file)
		delete mmap;
		mmap = NULL;
	}
}

void TRawData::SetMMap(TMMap & mm)
{
	if(mmap == NULL)
	{
		mmap = &mm;
		mem = mm.GetPointer();
		size = mm.GetSize();
	} 
	else
		EXCEPT("MMap allready in use, when trying to change it");
		
}

TRawData::TRawData(TRawData & old)
{
	// The copy constructor moves data to memory
	// and make a duplicate there.

	old.ReleaseFile();
	size= old.size;
	mmap = NULL;
	mem = new char[old.GetSize()];

	// Copy the data disk -> memory
	memcpy(mem, old.mem, GetSize());

}
