// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// AddressBookView.cpp : implementation file
//

#include "stdafx.h"

#include "hermes gui.h"
#include "AddressBookView.h"
#include "TAddress.h"
#include "TPostOffice.h"
#include "NewFrame.h"
#include "NewView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAddressBookView

IMPLEMENT_DYNCREATE(CAddressBookView, CFormView)

CAddressBookView::CAddressBookView()
	: CListView()
{
//	m_pListCtrl = NULL;

	//{{AFX_DATA_INIT(CAddressBookView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CAddressBookView::~CAddressBookView()
{
/*	if(m_pWabObject)
		delete m_pWabObject;
		*/
}

BEGIN_MESSAGE_MAP(CAddressBookView, CListView)
	//{{AFX_MSG_MAP(CAddressBookView)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_ADDR_POPUP_PROPERTIES, OnAddressProperties)
	ON_COMMAND(ID_ADDR_POPUP_NEW, OnAddressNew)
	ON_COMMAND(ID_ADDR_POPUP_DELETE, OnAddressDelete)
	ON_COMMAND(ID_ADDR_POPUP_SENDTO, OnAddressSendto)
	ON_COMMAND(ID_ADDR_POPUP_FIND, OnAddressFind)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAddressBookView diagnostics
/*
#ifdef _DEBUG
void CAddressBookView::AssertValid() const
{
	CFormView::AssertValid();
}

void CAddressBookView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif
*/
/////////////////////////////////////////////////////////////////////////////
// CAddressBookView message handlers

void CAddressBookView::OnInitialUpdate() 
{
	CListCtrl &ctr = GetListCtrl();
	ListView_SetExtendedListViewStyle(ctr.m_hWnd, LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	CString str;
	str.LoadString(STR_NAME);
	ctr.InsertColumn(0, str, LVCFMT_LEFT, 200,0);

	str.LoadString(STR_ADDRESS);
	ctr.InsertColumn(1, str, LVCFMT_LEFT,100,1);

	CListView::OnInitialUpdate();
	
}

void CAddressBookView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{

	TAddress* address;
	int i = 0;
	
	CListCtrl &ctr = GetListCtrl();
		
	ctr.DeleteAllItems();
	const TAddressList& al = postOffice.GetAddressBook()->GetAddressList();
	if(&al == NULL) return;

	POSITION pos;

	pos = al.GetHeadPosition();

	while (! (pos == NULL) )
	{
		address = al.GetNext(pos);

		// The user data is set to point to the letter object
		ctr.InsertItem(LVIF_TEXT| LVIF_PARAM, i, address->GetName(), 0,0,0,(LPARAM) address);
		ctr.SetItem(i, 1, LVIF_TEXT, address->GetAddress(), 0,0,0,0L);

		i++;
	}
}


BOOL CAddressBookView::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style &= ~LVS_TYPEMASK;	
	cs.style |= LVS_REPORT | LVS_AUTOARRANGE;
	return CListView::PreCreateWindow(cs);
}

void CAddressBookView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
    // make sure window is active    
	GetParentFrame()->ActivateFrame();
	CMenu menu;
	if (menu.LoadMenu(IDR_ADDRESSVIEW_POPUP)) 
	{
		CMenu* pPopup = menu.GetSubMenu(0);
        ASSERT(pPopup != NULL);
		pPopup->EnableMenuItem(0, MF_BYPOSITION|MF_ENABLED);
		if(pPopup->EnableMenuItem(ID_ADDR_POPUP_PROPERTIES, MF_ENABLED)
			 == -1) AfxMessageBox("Not valid");
//		pPopup->EnableMenuItem(ID_MENUPASTE, MF_ENABLED);
//		pPopup->EnableMenuItem(ID_MENUCOPY, MF_ENABLED);
        pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
                point.x, point.y,
                AfxGetMainWnd()); // use main window for cmds    
	}
	
}

void CAddressBookView::OnAddressProperties() 
{
	int i=0;
	bool found = false;

	CListCtrl& ctr = GetListCtrl();

	for(i=0; i < ctr.GetItemCount(); i++)
	{
		if(ctr.GetItemState(i, LVIS_SELECTED | LVIS_FOCUSED) != 0)
		{
			found = true;
			break;
		}
	}
	if(!found) return;

	postOffice.GetAddressBook()->AddressProperties((TAddress*)ctr.GetItemData(i), 
		AfxGetMainWnd()->m_hWnd);
	GetDocument()->UpdateAllViews(NULL);

	ctr.EnsureVisible(i, FALSE); // Restore the view layout (well, as good as possible anyway)

}

void CAddressBookView::OnAddressNew() 
{
	// TODO: Add your command handler code here
	if(postOffice.GetAddressBook()->AddAddress(AfxGetMainWnd()->m_hWnd))
		GetDocument()->UpdateAllViews(NULL);
	
}

void CAddressBookView::OnAddressDelete() 
{
	int i=0;
	bool found = false;

	CListCtrl& ctr = GetListCtrl();

	for(i=0; i < ctr.GetItemCount(); i++)
	{
		if(ctr.GetItemState(i, LVIS_SELECTED | LVIS_FOCUSED) != 0)
		{
			found = true;
			break;
		}
	}
	if(!found) return;

	if(MessageBox("This will PERMANENTLY delete the selected item.\nDo you wish to continue?",
		"Warning!", MB_ICONWARNING | MB_YESNO) == IDYES)
	{
		// Delete the address
		postOffice.GetAddressBook()->RemoveAddress((TAddress*)ctr.GetItemData(i));
		GetDocument()->UpdateAllViews(NULL);
	}
}

void CAddressBookView::OnAddressSendto() 
{
	CNewFrame* awnd;
	CCreateContext cc;
	int i=0;
	bool found = false;
	TAddressList recipients;
	
	CListCtrl& ctr = GetListCtrl();

	for(i=0; i < ctr.GetItemCount(); i++)
	{
		if(ctr.GetItemState(i, LVIS_SELECTED) != 0)
		{
			// Insert the address pointer in the list
			recipients.AddTail((TAddress*)ctr.GetItemData(i)); 
			found = true;
		}
	}
	if(!found) return;
	
	// The createcontext specifies which view to use when creating the window
	cc.m_pNewViewClass = RUNTIME_CLASS(CNewView);
	cc.m_pCurrentDoc = ((CFrameWnd*)AfxGetMainWnd())->GetActiveDocument();
	cc.m_pNewDocTemplate = NULL;
	cc.m_pLastView = NULL;
	cc.m_pCurrentFrame = NULL;

	awnd = new CNewFrame(recipients);
	awnd->LoadFrame(IDR_NEWFRAME, 
							WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE,
							NULL, 
							&cc);
	awnd->ActivateFrame();
	
}

void CAddressBookView::OnAddressFind() 
{
	postOffice.GetAddressBook()->FindAddress(AfxGetMainWnd()->m_hWnd);	
}
