// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// CHeaderView.cpp : implementation file
//

#include "stdafx.h"
#include "Hermes GUI.h"
#include "CHeaderView.h"
#include <stdlib.h>

// Hermes includes

#include "TLetter.h"
#include "TPostOffice.h"
#include "THeader.h"
#include "TFolder.h"
#include "Hermes GUIDoc.h" 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CHeaderView

IMPLEMENT_DYNCREATE(CHeaderView, CListView)

CHeaderView::CHeaderView()
{
}

CHeaderView::~CHeaderView()
{
}


BEGIN_MESSAGE_MAP(CHeaderView, CListView)
	//{{AFX_MSG_MAP(CHeaderView)
	ON_NOTIFY_REFLECT(NM_CLICK, OnClick)
	ON_WM_LBUTTONDOWN()
	ON_NOTIFY_REFLECT(LVN_COLUMNCLICK, OnColumnclick)
	ON_WM_CONTEXTMENU()
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_PASTE, OnUpdateEditPaste)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COPY, OnUpdateEditCopy)
	ON_UPDATE_COMMAND_UI(ID_EDIT_CUT, OnUpdateEditCut)
	ON_COMMAND(ID_POPUP_DELETE, OnPopupDelete)
	ON_UPDATE_COMMAND_UI(ID_POPUP_DELETE, OnUpdatePopupDelete)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CHeaderView drawing

void CHeaderView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();

}

/////////////////////////////////////////////////////////////////////////////
// CHeaderView diagnostics

#ifdef _DEBUG
void CHeaderView::AssertValid() const
{
	CListView::AssertValid();
}

void CHeaderView::Dump(CDumpContext& dc) const
{
	CListView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CHeaderView message handlers

void CHeaderView::OnInitialUpdate() 
{
	CListCtrl &ctr = GetListCtrl();
	ListView_SetExtendedListViewStyle(ctr.m_hWnd, LVS_EX_FULLROWSELECT);
	CString str;
	str.LoadString(STR_FROM);
	ctr.InsertColumn(0, str, LVCFMT_LEFT, 200,0);
	str.LoadString(STR_SUBJECT);
	ctr.InsertColumn(1, str, LVCFMT_LEFT,100,1);
	str.LoadString(STR_TO);
	ctr.InsertColumn(2, str, LVCFMT_LEFT,100,2);
	str.LoadString(STR_DATE);
	ctr.InsertColumn(3, str, LVCFMT_LEFT,100,2);
	
	CListView::OnInitialUpdate();
}



void CHeaderView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint ) 
{
	// Get the document 
	CHermesGUIDoc *doc = (CHermesGUIDoc *) GetDocument();

	TLetter* letter;
	TLetterList& ll = doc->folder->GetLetters();
	THeader *header;
	int i=0;
	
	CListView::OnUpdate(pSender, lHint, pHint);
	
	CListCtrl &ctr = GetListCtrl();

	ctr.DeleteAllItems();

	POSITION pos;

	pos = ll.GetHeadPosition();

	while (! (pos == NULL) )
	{
		letter = ll.GetNext(pos);
		header = &letter->GetHeader();
			

		CString tonames;
		TAddress* toadr;
		POSITION pos = header->GetTo().GetHeadPosition();
		while(pos != NULL)
		{
			toadr = header->GetTo().GetNext(pos);
			if(tonames.GetLength() > 0)
				tonames += ", ";
			tonames += toadr->GetName();
		}

		// The user data is set to point to the letter object
		ctr.InsertItem(LVIF_TEXT| LVIF_PARAM, i, header->GetFrom().GetName(), 0,0,0,(LPARAM) letter);
		ctr.SetItem(i, 1, LVIF_TEXT, header->GetSubject(), 0,0,0,0L);
		ctr.SetItem(i, 2, LVIF_TEXT, tonames, 0,0,0,0L);
		ctr.SetItem(i, 3, LVIF_TEXT, header->GetDate(), 0,0,0,0L);

		i++;
	}
	GetListCtrl().SortItems(Compare,0);
}



BOOL CHeaderView::PreCreateWindow(CREATESTRUCT& cs) 
{
	cs.style &= ~LVS_TYPEMASK;	
	cs.style |= LVS_REPORT; // LVS_OWNERDRAWFIXED
		
	return CListView::PreCreateWindow(cs);
}

void CHeaderView::OnClick(NMHDR* pNMHDR, LRESULT* pResult) 
{
	*pResult = 0;
}

void CHeaderView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// Get the document 
	CHermesGUIDoc *doc = (CHermesGUIDoc *) GetDocument();

	UINT uFlags = 0;

		// Test if the mouse is over an item in the listcontrol
	int nHitItem = GetListCtrl().HitTest(point, &uFlags);

		// Only consider the mousepress if it was over an item label
	if((uFlags & LVHT_ONITEMLABEL) != 0) {
//		MessageBox(GetListCtrl().GetItemText(nHitItem,0)); // Show the item text

		// If the letter is clicked then update the document pointer to th current letter
		TLetter *letter = (TLetter *) GetListCtrl().GetItemData(nHitItem);
		doc->letter = letter;
	}
		// Call the original LButtonDown handler (probably stub:ed)
	CListView::OnLButtonDown(nFlags, point);

	// Inform all the other view that the data has changed
	doc->UpdateAllViews(this);
}


void CHeaderView::OnColumnclick(NMHDR* pNMHDR, LRESULT* pResult) 
{	
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// This is called when the users clicks on the header of a column.

	//pNMListView->iSubItem contains the clicked column! 
	//Idenifies which column to sort by.

	if(!GetListCtrl().SortItems(Compare,pNMListView->iSubItem))
		AfxMessageBox("Error sorting messages.");
	*pResult = 0;
}

int CALLBACK CHeaderView::Compare(LPARAM lParam1, LPARAM lParam2, LPARAM lParamSort)
{
	TLetter *letter1 = (TLetter *) lParam1;
	TLetter *letter2 = (TLetter *) lParam2;
	switch(lParamSort)
	{
		case 0:		// Fromfield
			return letter1->GetHeader().GetFrom().GetName() > 
					  letter2->GetHeader().GetFrom().GetName();
		case 1:		// Subjectfield
			return letter1->GetHeader().GetSubject() > 
					  letter2->GetHeader().GetSubject();
		case 2:		// Tofield
			return letter1->GetHeader().GetTo().GetHead()->GetName() > 
					  letter2->GetHeader().GetTo().GetHead()->GetName();
		case 3:		// Datefield
			return letter1->GetHeader().GetCTime() > 
					  letter2->GetHeader().GetCTime();
	}
	// This should never occur
	AfxMessageBox("Error in sorting header fields");
	return 0;
}

void CHeaderView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
    // make sure window is active    
	GetParentFrame()->ActivateFrame();
	CMenu menu;
	if (menu.LoadMenu(IDR_FOLDER_POPUP)) 
	{
		CMenu* pPopup = menu.GetSubMenu(0);
        ASSERT(pPopup != NULL);
		pPopup->EnableMenuItem(0, MF_BYPOSITION|MF_ENABLED);
//		pPopup->EnableMenuItem(ID_MENUPASTE, MF_ENABLED);
//		pPopup->EnableMenuItem(ID_MENUCOPY, MF_ENABLED);
        pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
                point.x, point.y,
                AfxGetMainWnd()); // use main window for cmds    
	}
}

void CHeaderView::OnEditCopy() 
{
	// tell the clipboard that the current letter is to be copied.
	CHermesGUIDoc *doc = (CHermesGUIDoc *) GetDocument();
	
	// When we copy a letter we create a new copy of the letter.
	doc->clipboardletter = new TLetter(*doc->letter);	
}


void CHeaderView::OnEditCut() 
{
	// tell the clipboard that the current letter is to be copied.
	CHermesGUIDoc *doc = (CHermesGUIDoc *) GetDocument();

	doc->clipboardletter = doc->letter;	
}

void CHeaderView::OnEditPaste() 
{
	// Move the letter to the currently selected folder.
	CHermesGUIDoc *doc = (CHermesGUIDoc *) GetDocument();

	postOffice.PlaceLetter(*doc->clipboardletter, *doc->folder);
	doc->UpdateAllViews(NULL);
}

void CHeaderView::OnUpdateEditPaste(CCmdUI* pCmdUI) 
{
	// Called when displaying the paste meny item, only shown when a selected letter exists.
	if(((CHermesGUIDoc *) GetDocument())->clipboardletter != NULL)
		pCmdUI->Enable(true);
	else
		pCmdUI->Enable(false);
}

void CHeaderView::OnUpdateEditCopy(CCmdUI* pCmdUI) 
{
	// Called when displaying the Copy meny item, only shown when a selected letter exists.
	if(((CHermesGUIDoc *) GetDocument())->letter != NULL)
		pCmdUI->Enable(true);
	else
		pCmdUI->Enable(false);
}

void CHeaderView::OnUpdateEditCut(CCmdUI* pCmdUI) 
{
	// Called when displaying the Cut meny item, only shown when a selected letter exists.
	if(((CHermesGUIDoc *) GetDocument())->letter != NULL)
		pCmdUI->Enable(true);
	else
		pCmdUI->Enable(false);
}

void CHeaderView::OnPopupDelete() 
{
	// The user want to delete the selected letter(s)
	CHermesGUIDoc *doc = (CHermesGUIDoc *) GetDocument();
	CListCtrl& ctr = GetListCtrl();
	
	LV_ITEM itemstruct;
	itemstruct.mask = LVIF_PARAM;
	itemstruct.iSubItem = 0;
	int item= -1;	// find the first item the first time

	while((item = ctr.GetNextItem(item, LVNI_SELECTED)) != -1)
	{
		itemstruct.iItem = item;
		ctr.GetItem(&itemstruct);
		postOffice.PlaceLetter(*((TLetter *) itemstruct.lParam), postOffice.FindFolder(TPostOffice::trashID));
	}
	doc->letter = NULL;
	doc->UpdateAllViews(NULL);
}

void CHeaderView::OnUpdatePopupDelete(CCmdUI* pCmdUI) 
{
	// Called when the GUI wants to show the "delete" menu.
	if(((CHermesGUIDoc *) GetDocument())->letter != NULL)
		pCmdUI->Enable(true);
	else
		pCmdUI->Enable(false);
	
}
