// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// FolderView.cpp : implementation file
//

#include "stdafx.h"
#include "hermes gui.h"
#include "FolderView.h"

#include "TPostOffice.h"
#include "TFolder.h"
#include "Hermes GUIDoc.h" 
#include "RenameDialog.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CFolderView

IMPLEMENT_DYNCREATE(CFolderView, CTreeView)

CFolderView::CFolderView()
{
	isdragging = false;
}

CFolderView::~CFolderView()
{
}


BEGIN_MESSAGE_MAP(CFolderView, CTreeView)
	//{{AFX_MSG_MAP(CFolderView)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	ON_COMMAND(ID_EDIT_CUT, OnEditCut)
	ON_COMMAND(ID_EDIT_COPY, OnEditCopy)
	ON_COMMAND(ID_EDIT_PASTE, OnEditPaste)
	ON_COMMAND(ID_POPUP_NEW, OnPopupNew)
	ON_COMMAND(ID_POPUP_DELETE, OnPopupDelete)
	ON_UPDATE_COMMAND_UI(ID_POPUP_DELETE, OnUpdatePopupDelete)
	ON_COMMAND(ID_POPUP_RENAME, OnPopupRename)
	ON_COMMAND(ID_POPUP_EMPTYTRASH, OnPopupEmptytrash)
	ON_NOTIFY_REFLECT(TVN_BEGINDRAG, OnBegindrag)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONUP()
	ON_WM_CONTEXTMENU()
	ON_WM_RBUTTONUP()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFolderView drawing

void CFolderView::OnDraw(CDC* pDC)
{
	CDocument* pDoc = GetDocument();
	// TODO: add draw code here
}

/////////////////////////////////////////////////////////////////////////////
// CFolderView diagnostics

#ifdef _DEBUG
void CFolderView::AssertValid() const
{
	CTreeView::AssertValid();
}

void CFolderView::Dump(CDumpContext& dc) const
{
	CTreeView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CFolderView message handlers

void CFolderView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	CTreeView::OnUpdate(pSender, lHint, pHint);
	
	TFolder* folder;

	folder = &postOffice.FindFolder(TPostOffice::rootID);

	CTreeCtrl& ctr = GetTreeCtrl();

	// First we have to clear the tree view
	GetTreeCtrl().DeleteAllItems();

	// We have to implement an image list in order have icons
	// + drag and drop requires an image list.
	
	CImageList *imagelist = new CImageList;

	imagelist->Create(IDB_TREEIMAGE, 16,10, 10);

	ctr.SetImageList(imagelist, TVSIL_NORMAL);

	// Then we insert all the items recursively
	InsertFolder(*folder);

	GetTreeCtrl().Expand(GetTreeCtrl().GetRootItem(), TVE_EXPAND);


}

void CFolderView::InsertFolder(TFolder & folder, HTREEITEM parent)
{
	HTREEITEM me;
	TFolderList* fl;
	POSITION pos;
	TFolder* child;

	CTreeCtrl& ctr = GetTreeCtrl();



	CString str;
	char buf[80];
	str = folder.GetName();
	// Add the number of messages in folder to the name if unempty
	if(folder.GetLetters().GetCount() > 0)
		str += CString(" (")+ CString(_itoa(folder.GetLetters().GetCount(),buf, 10)) + CString(")");

	me = ctr.InsertItem(TVIF_PARAM | TVIF_TEXT, str, 0, 0, 0, 0, 
			(LPARAM) &folder, parent, TVI_SORT); // Insert ROOT folder
	fl = &folder.GetSubFolders();
	pos = fl->GetHeadPosition();

	while( !(pos == NULL) )
	{
		child = fl->GetNext(pos);
		InsertFolder(*child, me);
	}
}

BOOL CFolderView::PreCreateWindow(CREATESTRUCT& cs) 
{
//	cs.style &= ~TVS_TYPEMASK;
	cs.style |= TVS_HASLINES | TVS_HASBUTTONS | TVS_LINESATROOT;
	
	return CTreeView::PreCreateWindow(cs);
}

void CFolderView::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	CHermesGUIDoc *doc = (CHermesGUIDoc *) GetDocument();
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;

	CTreeCtrl& ctr = GetTreeCtrl();

	TV_ITEM item;
	if((pNMTreeView->itemOld.hItem) != 0)
	{
		item = pNMTreeView->itemNew;
		TFolder* folder = (TFolder *) item.lParam;
		// Set the current folder and set no letter
		doc->folder = folder;
		
		// Set the letter to the first in folder or no letter if empty
		if(!folder->GetLetters().IsEmpty())
			doc->letter = folder->GetLetters().GetHead();
		else
			doc->letter = NULL;

		// Inform the others about changes
		doc->UpdateAllViews(this);
	}

	*pResult = 0;
}

void CFolderView::OnContextMenu(CWnd* pWnd, CPoint point) 
{
/*    // make sure window is active    
	GetParentFrame()->ActivateFrame();
	CMenu menu;
	if (menu.LoadMenu(IDR_FOLDER_POPUP)) 
	{
		CMenu* pPopup = menu.GetSubMenu(0);
        ASSERT(pPopup != NULL);
		pPopup->EnableMenuItem(0, MF_BYPOSITION|MF_ENABLED);
//		pPopup->EnableMenuItem(ID_MENUPASTE, MF_ENABLED);
//		pPopup->EnableMenuItem(ID_MENUCOPY, MF_ENABLED);
        pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
                point.x, point.y,
                AfxGetMainWnd()); // use main window for cmds    
	}
*/}


void CFolderView::OnEditCut() 
{
	// TODO: Add your command handler code here
	
}

void CFolderView::OnEditCopy() 
{
	// TODO: Add your command handler code here
	
}

void CFolderView::OnEditPaste() 
{
	// TODO: Add your command handler code here
	
}

void CFolderView::OnPopupNew() 
{
	// We want to add a folder to the current folder.
	CHermesGUIDoc *doc = (CHermesGUIDoc *) GetDocument();

	TFolder *newfolder = new TFolder(CString("New"));
	postOffice.PlaceFolder(*newfolder, *doc->folder);

	doc->UpdateAllViews(NULL);
}

void CFolderView::OnPopupDelete() 
{
	// The user wants to delete a folder		
	CHermesGUIDoc *doc = (CHermesGUIDoc *) GetDocument();
	TRY_CATCH(postOffice.PlaceFolder(*doc->folder, postOffice.FindFolder(TPostOffice::trashID)));

	doc->UpdateAllViews(NULL);
	
}

void CFolderView::OnUpdatePopupDelete(CCmdUI* pCmdUI) 
{
	// Called when the GUI wants to show the "delete" menu on a folder
	if(((CHermesGUIDoc *) GetDocument())->folder != NULL)
		pCmdUI->Enable(true);
	else
		pCmdUI->Enable(false);
	
}

void CFolderView::OnPopupRename() 
{
	CHermesGUIDoc *doc = (CHermesGUIDoc *) GetDocument();

	CTreeCtrl& ctr = GetTreeCtrl();
	CRenameDialog renamedlg;
	renamedlg.m_Name = doc->folder->GetName();
	if(renamedlg.DoModal() ==IDOK)
		doc->folder->Rename(renamedlg.m_Name);
	doc->UpdateAllViews(NULL);
}

void CFolderView::OnPopupEmptytrash() 
{
	CHermesGUIDoc *doc = (CHermesGUIDoc *) GetDocument();
	// This is called when the users wants to empty his trash can.
	TFolder &trash = postOffice.FindFolder(TPostOffice::trashID);
	POSITION pos = trash.GetLetters().GetHeadPosition();
	while( pos != NULL)
	{
		postOffice.DeleteLetter(*(trash.GetLetters().GetNext(pos)));
	}

	pos = trash.GetSubFolders().GetHeadPosition();
	while( pos != NULL)
	{
		postOffice.DeleteFolder(*(trash.GetSubFolders().GetNext(pos)));
	}

	doc->letter = NULL;
	doc->folder = &postOffice.GetRootFolder();
	doc->clipboardletter = NULL;
	doc->clipboardfolder = NULL;

	GetDocument()->UpdateAllViews(NULL);
}

void CFolderView::OnBegindrag(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	CTreeCtrl& ctr = GetTreeCtrl();


	if(!(pNMTreeView->hdr.code == TVN_BEGINDRAG))
		AfxMessageBox("Not an BEGINDRAG message");

	if(!(m_pDragImage = ctr.CreateDragImage(pNMTreeView->itemNew.hItem)))
		AfxMessageBox("Could not create drag image");
	else
	{
		m_pDragImage->BeginDrag(0, CPoint(1,1));//pNMTreeView->ptDrag);
		m_pDragImage->GetImageCount();

		dragfolder = (TFolder *) pNMTreeView->itemNew.lParam;
	}
	isdragging = true;
	*pResult = 0;
}
void CFolderView::OnMouseMove(UINT nFlags, CPoint point) 
{
	if(isdragging)
	{
		m_pDragImage->DragMove(point);
//		m_pDragImage->Draw(GetDC(),0, point, ILD_TRANSPARENT);
		m_pDragImage->Draw(GetDC(),0, point, ILD_BLEND);		
	}

//	CTreeView::OnMouseMove(nFlags, point);
}

void CFolderView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	if(isdragging)
	{
		// We are in drag and drop mode!
		CTreeCtrl& ctr = GetTreeCtrl();
		isdragging = false;
		UINT flags;
		
		TV_ITEM item;
		item.mask = TVIF_HANDLE;

		item.hItem = ctr.HitTest(point, &flags);
		if(flags & TVHT_ONITEM)
		{
			// We have found an item that was under the mouse
			ctr.GetItem(&item);

			TFolder *targetfolder = (TFolder *) item.lParam;
			// Now we can place the folder in the new folder

			TRY_CATCH(postOffice.PlaceFolder(*dragfolder, *targetfolder));

			// Tell the other that the data has changed!
//			AfxMessageBox("Drag and drop complete");
		}
		GetDocument()->UpdateAllViews(NULL);
	}

	CTreeView::OnLButtonUp(nFlags, point);
}


void CFolderView::OnRButtonUp(UINT nFlags, CPoint point) 
{
    // make sure window is active    
	GetParentFrame()->ActivateFrame();
	CMenu menu;
	if (menu.LoadMenu(IDR_FOLDER_POPUP)) 
	{
		CMenu* pPopup = menu.GetSubMenu(0);
        ASSERT(pPopup != NULL);
		CRect rect;
		GetWindowRect(rect);
		pPopup->EnableMenuItem(0, MF_BYPOSITION|MF_ENABLED);
        pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON,
                rect.left +point.x, rect.top + point.y,
                AfxGetMainWnd()); // use main window for cmds    
	}
	
//	CTreeView::OnRButtonUp(nFlags, point);
}
