// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "Hermes GUI.h"

#include "MainFrm.h"
#include "Splash.h"
#include "CHeaderView.h"
#include "FolderView.h"
#include "LetterView.h"
#include "NewView.h"
#include "CAddressWnd.h"
#include "NewFrame.h"
#include "AddressBookView.h"
#include "Hermes GUIDoc.h"
#include "PreferencesDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNCREATE(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_UPDATE_COMMAND_UI(ID_SHOWADDRESSFRAME, OnUpdateShowAddressFrame)
	ON_COMMAND(ID_SHOWADDRESSFRAME, OnShowAddressFrame)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_CHECK_MAIL, OnCheckMail)
	ON_MESSAGE(WM_RECEIVEMAIL, OnNewMail)
	ON_MESSAGE(WM_OUTGOINGMAIL, OnOutGoingMail)
	ON_COMMAND(ID_PREFERENCES, OnPreferences)
	ON_WM_PAINT()
	ON_COMMAND(ID_REPLY, OnReply)
	ON_UPDATE_COMMAND_UI(ID_REPLY, OnUpdateReply)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar.Create(this) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Remove this if you don't want tool tips or a resizeable toolbar
	m_wndToolBar.SetBarStyle(m_wndToolBar.GetBarStyle() |
		CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC);

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);

	// CG: The following line was added by the Splash Screen component.
	CSplashWnd::ShowSplashScreen(this);
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs
	return CFrameWnd::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers

BOOL CMainFrame::OnCreateClient(LPCREATESTRUCT lpcs, CCreateContext* pContext)
{
	// CG: The following block was added by the Split Bars component.
	{
		if (!m_wndSplitter.CreateStatic(this,
		                          2, 2))
		{
			TRACE0("Failed to create split bar ");
			return FALSE;    // failed to create
		}

		if(!m_wndSplitter.CreateView(0, 0, RUNTIME_CLASS(CFolderView), CSize(250,200), pContext))
			AfxMessageBox("00");

		if(!m_wndSplitter.CreateView(0, 1, RUNTIME_CLASS(CHeaderView), CSize(600 ,200), pContext))
			AfxMessageBox("01");

		if(!m_wndSplitter.CreateView(1, 0, RUNTIME_CLASS(CAddressBookView), CSize(250 ,150), pContext))
			AfxMessageBox("10");

		if(!m_wndSplitter.CreateView(1, 1, RUNTIME_CLASS(CLetterView), CSize(1000,600), pContext))
			AfxMessageBox("11");
		return TRUE;
	}
}

void CMainFrame::OnUpdateShowAddressFrame(CCmdUI* pCmdUI) 
{
	pCmdUI->Enable();	
}

void CMainFrame::OnShowAddressFrame() 
{
	CAddressWnd* awnd;
	CCreateContext cc;

	cc.m_pNewViewClass = RUNTIME_CLASS(CAddressBookView);
	cc.m_pCurrentDoc = GetActiveDocument();
	cc.m_pNewDocTemplate = NULL;
	cc.m_pLastView = NULL;
	cc.m_pCurrentFrame = this;


	awnd = new CAddressWnd;
	awnd->LoadFrame(IDR_ADDRESSFRAME,
							WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE,
							this, 
							&cc);
	awnd->ActivateFrame();
	awnd->UpdateWindow();
}

void CMainFrame::OnFileNew() 
{
	CNewFrame* awnd;
	CCreateContext cc;
	
	// The createcontext specifies which view to use when creating the window
	cc.m_pNewViewClass = RUNTIME_CLASS(CNewView);
	cc.m_pCurrentDoc = GetActiveDocument();
	cc.m_pNewDocTemplate = NULL;
	cc.m_pLastView = NULL;
	cc.m_pCurrentFrame = NULL;

	awnd = new CNewFrame;
	awnd->LoadFrame(IDR_NEWFRAME, 
							WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE,
							NULL, 
							&cc);
	awnd->ActivateFrame();

}

void CMainFrame::OnCheckMail() 
{
	// Ask the Mailbox to get some mail
	postOffice.GetMailBox().CheckMail();

}

LONG CMainFrame::OnNewMail(UINT, LONG)
{
	// This is needed for the mailbox to work
	// See TMailBox for further info.
	postOffice.GetMailBox().msg_ReceiveMail();
	// Update the view to show the new messages.
	GetActiveDocument()->UpdateAllViews(NULL);
	return 0;
}

LONG CMainFrame::OnOutGoingMail(UINT, LONG)
{
	postOffice.GetMailBox().msg_ListOutgoingMail();
	return 0;
}

void CMainFrame::OnPreferences() 
{
	// When preferences.., is chosed in edit window
	TPreference& prefs = postOffice.GetPreference();
	CPreferencesDialog dlg;
	dlg.m_Name = prefs.GetUserName(); 
	dlg.m_Address = prefs.GetMailAddress(); 
	dlg.m_UserID = prefs.GetUserID(); 
	dlg.m_PassWord = prefs.GetPassWord(); 
	dlg.m_POPServer = prefs.GetPOPServer(); 
	dlg.m_SMTPServer = prefs.GetSMTPServer();
	dlg.m_CheckMailTime = (prefs.GetCheckMailTime()/60000); // Timeconversion
	dlg.m_LeaveOnServer = prefs.GetLeaveOnServer();
	dlg.m_CheckMail = prefs.GetCheckMail();
	dlg.m_OnlyNewMail = prefs.GetOnlyNewMail();
	
	if (dlg.DoModal() == IDOK)
	{
		//If OK button is clicked
		prefs.SetUserName(dlg.m_Name); 
		prefs.SetMailAddress(dlg.m_Address); 
		prefs.SetUserID(dlg.m_UserID); 
		prefs.SetPassWord(dlg.m_PassWord); 
		prefs.SetPOPServer(dlg.m_POPServer); 
		prefs.SetSMTPServer(dlg.m_SMTPServer);
		prefs.SetCheckMailTime((dlg.m_CheckMailTime * 60000)); // Timeconversion
		prefs.SetLeaveOnServer(dlg.m_LeaveOnServer);
		prefs.SetCheckMail(dlg.m_CheckMail);
		prefs.SetOnlyNewMail(dlg.m_OnlyNewMail);

		//Save our preferences to disk 
		postOffice.GetIO().SavePreference(prefs);
	}
}


//SetDlgItemText and GetDlgItemText 

void CMainFrame::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	// TODO: Add your message handler code here
	static CString str;
	if(str.IsEmpty())
		str.LoadString(AFX_IDS_APP_TITLE);

	SetWindowText(str);
	
	// Do not call CFrameWnd::OnPaint() for painting messages
}

void CMainFrame::OnReply() 
{
	if(((CHermesGUIDoc *)GetActiveDocument())->letter)
	{
		CNewFrame* awnd;
		CCreateContext cc;
	
		CHermesGUIDoc* doc = (CHermesGUIDoc*) GetActiveDocument();

		// The createcontext specifies which view to use when creating the window
		cc.m_pNewViewClass = RUNTIME_CLASS(CNewView);
		cc.m_pCurrentDoc = GetActiveDocument();
		cc.m_pNewDocTemplate = NULL;
		cc.m_pLastView = NULL;
		cc.m_pCurrentFrame = NULL;

		awnd = new CNewFrame(*doc->letter);
		awnd->LoadFrame(IDR_NEWFRAME, 
							WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE,
							NULL, 
							&cc);
		awnd->ActivateFrame();
	}
	else
	{
		AfxMessageBox("No message to reply to!");
	}
}

void CMainFrame::OnUpdateReply(CCmdUI* pCmdUI) 
{
	// TODO: Add your command update UI handler code here
	if(((CHermesGUIDoc *) GetActiveDocument())->letter != NULL)
		pCmdUI->Enable(true);
	else
		pCmdUI->Enable(false);
}
