// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// NewView.cpp : implementation file
//

#include "stdafx.h"
#include "TAddress.h"
#include "hermes gui.h"
#include "NewView.h"
#include "TAddress.h"
#include "THeader.h"
#include "TLetter.h"
#include "CAddressWnd.h"
#include "AddressBookView.h"
#include "NewFrame.h"
#include "TAddressBook.h"
#include "LetterView.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CNewView

IMPLEMENT_DYNCREATE(CNewView, CFormView)

CNewView::CNewView()
	: CFormView(CNewView::IDD)
{
	//{{AFX_DATA_INIT(CNewView)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}

CNewView::~CNewView()
{
}

void CNewView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CNewView)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CNewView, CFormView)
	//{{AFX_MSG_MAP(CNewView)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_NEWSENDBUTTON, OnNewsendbutton)
	ON_BN_CLICKED(IDC_CCADDRESSBOOK, OnCcaddressbook)
	ON_BN_CLICKED(IDC_TOADDRESSBOOK, OnToaddressbook)
	ON_BN_CLICKED(IDC_NEWABORTBUTTON, OnNewabortbutton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CNewView diagnostics

#ifdef _DEBUG
void CNewView::AssertValid() const
{
	CFormView::AssertValid();
}

void CNewView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CNewView message handlers

void CNewView::OnSize(UINT nType, int cx, int cy) 
{
	CFormView::OnSize(nType, cx, cy);

//	Try to resize the view itself, doesnt work???
//	SetWindowPos(NULL, 0, 0, 
//			cx-40,  cy-40, SWP_NOMOVE | SWP_NOZORDER);

	CWnd* ctr = GetDlgItem(IDC_NEWBODYFIELD);	

	// If the control hasn't yet been created a null pointer is returned
	if(ctr != NULL)
		ctr->SetWindowPos(NULL, 0, 0, 
			cx-30,  cy-150, SWP_NOMOVE | SWP_NOZORDER);

	ctr = GetDlgItem(IDC_NEWTOFIELD);	

	// If the control hasn't yet been created a null pointer is returned
	if(ctr != NULL)
		ctr->SetWindowPos(NULL, 0, 0, 
			cx-150,  24, SWP_NOMOVE | SWP_NOZORDER);

	ctr = GetDlgItem(IDC_NEWCCFIELD);	

	// If the control hasn't yet been created a null pointer is returned
	if(ctr != NULL)
		ctr->SetWindowPos(NULL, 0, 0, 
			cx-150,  24, SWP_NOMOVE | SWP_NOZORDER);

	ctr =GetDlgItem(IDC_NEWSUBJECTFIELD);	

	// If the control hasn't yet been created a null pointer is returned
	if(ctr != NULL)
		ctr->SetWindowPos(NULL, 0, 0, 
			cx-100,  24, SWP_NOMOVE | SWP_NOZORDER);

	ctr =GetDlgItem(IDC_NEWABORTBUTTON);	

	// If the control hasn't yet been created a null pointer is returned
	if(ctr != NULL)
		ctr->SetWindowPos(NULL, cx-120, 94, 
			0,  0, SWP_NOSIZE | SWP_NOZORDER);

	ctr = GetDlgItem(IDC_TOADDRESSBOOK);	

	// If the control hasn't yet been created a null pointer is returned
	if(ctr != NULL)
		ctr->SetWindowPos(NULL, cx-70, 12, 
			0,  0, SWP_NOSIZE | SWP_NOZORDER);

	ctr =GetDlgItem(IDC_CCADDRESSBOOK);	

	// If the control hasn't yet been created a null pointer is returned
	if(ctr != NULL)
		ctr->SetWindowPos(NULL, cx-70, 36, 
			0,  0, SWP_NOSIZE | SWP_NOZORDER);
	
}

BOOL CNewView::PreCreateWindow(CREATESTRUCT& cs) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CFormView::PreCreateWindow(cs);
}

void CNewView::OnNewsendbutton() 
{
	CEdit* toctr = (CEdit *) GetDlgItem(IDC_NEWTOFIELD);	
	CEdit* ccctr = (CEdit *) GetDlgItem(IDC_NEWCCFIELD);	
	CEdit* subjectctr = (CEdit *) GetDlgItem(IDC_NEWSUBJECTFIELD);	
	CEdit* bodyctr =  (CEdit *) GetDlgItem(IDC_NEWBODYFIELD);	
	
	TAddressList* tolist = new TAddressList;
	TAddressList* cclist = new TAddressList;
	TAddress* recipient;
	CString str,adr;
	toctr->GetWindowText(str);

	if(str.Find(',') == -1)
	{
		adr = str;
		str = CString("");
	}
	else
	{
		adr = str.Left(str.Find(','));
		str = str.Mid(str.Find(',')+1);
	}

	adr.TrimRight();
	adr.TrimLeft();

	while(adr != "")
	{
		if(postOffice.GetAddressBook()->IsEmailAddress(adr))
		{
			recipient = new TAddress(adr,adr);
			tolist->AddTail(recipient);
		}
		else
		{
			recipient = postOffice.GetAddressBook()->Lookup(adr);
			if(recipient == NULL)
			{
				CString errString = "The name " + adr + 
					" was unresolved.\nDiscard this recipient and continue anyway?";
				if(MessageBox(errString, "Warning!", MB_ICONWARNING | MB_YESNO) == IDNO)
				{
					delete tolist;
					delete cclist;
					return; // Exit function
				}
			}
			else 
			{
				tolist->AddTail(recipient);
			}
		}
		int i = str.Find(',');
		if((i == -1) && (str.GetLength() != 0)) // The rest of the string is a name or an address
		{
			adr = str;
			str = "";
		}
		else
		{
			adr = str.Left(i);
		}
		adr.TrimRight();
		adr.TrimLeft();

		str = str.Mid(str.Find(',')+1);
	}

	ccctr->GetWindowText(str);

	if(str.Find(',') == -1)
	{
		adr = str;
		str = CString("");
	}
	else
	{
		adr = str.Left(str.Find(','));
		str = str.Mid(str.Find(',')+1);
	}

	adr.TrimRight();
	adr.TrimLeft();

	while(adr != "")
	{
		if(postOffice.GetAddressBook()->IsEmailAddress(adr))
		{
			recipient = new TAddress(adr,adr);
			cclist->AddTail(recipient);
		}
		else
		{
			recipient = postOffice.GetAddressBook()->Lookup(adr);
			if(recipient == NULL)
			{
				CString errString = "The name " + adr + 
					" was unresolved.\nDiscard this recipient and continue anyway?";
				if(MessageBox(errString, "Warning!", MB_ICONWARNING | MB_YESNO) == IDNO)
				{
					delete tolist;
					delete cclist;
					return; // Exit function
				}
			}
			else 
			{
				cclist->AddTail(recipient);
			}
		}
		int i = str.Find(',');
		if((i == -1) && (str.GetLength() != 0)) // The rest of the string is a name or an address
		{
			adr = str;
			str = "";
		}
		else
		{
			adr = str.Left(i);
		}
		adr.TrimRight();
		adr.TrimLeft();

		str = str.Mid(str.Find(',')+1);
	}


	subjectctr->GetWindowText(str);

	CTime currenttime = CTime::GetCurrentTime();

	THeader* header = new THeader(
									*tolist, 
									*new TAddress(postOffice.GetPreference().GetMailAddress(),
															postOffice.GetPreference().GetUserName()),
									*cclist,
									*new CString(str),
									*new CTime(CTime::GetCurrentTime()),
									0);

	bodyctr->GetWindowText(str);

	TLetter* letter = new TLetter(*header, *new CString(str));

	postOffice.PlaceLetter(*letter, postOffice.FindFolder(TPostOffice::outBoxID));

	GetParent()->DestroyWindow();
}

void CNewView::OnInitialUpdate() 
{
	CFormView::OnInitialUpdate();
	
	
}

void CNewView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CBitmap* bm = new CBitmap;

	bm->LoadBitmap(IDB_ADDRESSBOOK);
	((CButton *) GetDlgItem(IDC_TOADDRESSBOOK))->SetBitmap(*bm);
	((CButton *) GetDlgItem(IDC_CCADDRESSBOOK))->SetBitmap(*bm);
	
}

void CNewView::CalcWindowRect(LPRECT lpClientRect, UINT nAdjustType) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	CFormView::CalcWindowRect(lpClientRect, nAdjustType);
}

void CNewView::OnActivateView(BOOL bActivate, CView* pActivateView, CView* pDeactiveView) 
{
	// TODO: Add your specialized code here and/or call the base class
	CFormView::OnActivateView(bActivate, pActivateView, pDeactiveView);
}
BOOL CNewView::Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	BOOL res = CFormView::Create(lpszClassName, lpszWindowName, dwStyle, rect, pParentWnd, nID, pContext);
	CBitmap* bm = new CBitmap;

	bm->LoadBitmap(IDB_ADDRESSBOOK);
	((CButton *) GetDlgItem(IDC_TOADDRESSBOOK))->SetBitmap(*bm);
	((CButton *) GetDlgItem(IDC_CCADDRESSBOOK))->SetBitmap(*bm);
	CNewFrame* frame = (CNewFrame *) GetParent();
	
	CString str;
	if((frame->tolist) != NULL)
	{
		TAddress *adr;
		POSITION pos = frame->tolist->GetHeadPosition();
		while(pos != NULL)
		{
			adr = frame->tolist->GetNext(pos);
			str += adr->GetName() + ", ";
		}
	}

	GetDlgItem(IDC_NEWTOFIELD)->SetWindowText(str);
	if(!frame->subject.IsEmpty())
	{
		GetDlgItem(IDC_NEWSUBJECTFIELD)->SetWindowText(CString("Re: ") 
									+ frame->subject);
		GetDlgItem(IDC_NEWBODYFIELD)->SetWindowText(
								ConvertString(CString("\n\n\n\nOriginal messages follows:\n\n---------------------------------------\n\n") + 
							frame->replytext));
	}
	return res; 
}


void CNewView::OnCcaddressbook() 
{
	// TODO: Add your control notification handler code here
	CAddressWnd* awnd;
	CCreateContext cc;

	cc.m_pNewViewClass = RUNTIME_CLASS(CAddressBookView);
	cc.m_pCurrentDoc = GetDocument();
	cc.m_pNewDocTemplate = NULL;
	cc.m_pLastView = NULL;
	cc.m_pCurrentFrame = (CFrameWnd *) GetParent();


	awnd = new CAddressWnd;
	awnd->LoadFrame(IDR_ADDRESSFRAME,
							WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE,
							this, 
							&cc);
	awnd->ActivateFrame();
	awnd->UpdateWindow();
}

void CNewView::OnToaddressbook() 
{
	CNewFrame* awnd;
	CCreateContext cc;

	cc.m_pNewViewClass = RUNTIME_CLASS(CAddressBookView);
	cc.m_pCurrentDoc = GetDocument();
	cc.m_pNewDocTemplate = NULL;
	cc.m_pLastView = NULL;
	cc.m_pCurrentFrame = NULL;

	awnd = new CNewFrame;
	awnd->LoadFrame(IDR_NEWFRAME, 
							WS_OVERLAPPEDWINDOW | FWS_ADDTOTITLE,
							NULL, 
							&cc);
	awnd->ActivateFrame();

}

void CNewView::OnNewabortbutton() 
{
	// TODO: Add your control notification handler code here
	GetParent()->DestroyWindow();	
}

