// $Header: /Hermes GUI/TAddress.cpp 20    97-12-02 23:41 Peblin $
// $Log: /Hermes GUI/TAddress.cpp $
//
//20    97-12-02 23:41 Peblin
//Added data field in address
//
//19    97-11-30 18:45 Fcl
//Added decoding of the header fields via an DecodeMIMEHeader function
//
//18    97-11-29 13:09 Fcl
//Added: an empty name field causes the address to be copied.
//
//17    97-11-28 23:38 Fcl
//Add cut&paste support in the header view!
//
//16    97-11-26 13:03 Peblin
//Fixed precompiled headers and a nice layout for the workspace
//
//15    97-11-23 13:26 Peblin
//Added socket support
//
//14    97-11-15 21:40 Fcl
//First tested version. Is able to save and load folders with no letters
//inside
//
//13    97-11-14 19:31 Fcl
//Check in to be able to move the repository to mandel.
//
//12    97-11-14 13:10 Fcl
//removed some const-return types... Const is for loosers
//
//11    97-11-07 16:49 Peblin
//Fixed const declarations
//
//10    97-11-07 14:13 Peblin
//Tried converting lists to instances and references. Didnt work.
//
//9     97-11-07 11:25 Peblin
//testing
//
//8     97-11-07 9:37 Peblin
//All functionallity implemented. Compiles.
//
//7     97-11-06 21:58 Fcl
//Added Header and Log statements at the top of each file

// TAddress.cpp: implementation of the TAddress class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TAddress.h"
#include "THeader.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TAddress::TAddress(CString inAddress, CString inName)
{
	address = inAddress;
	// If the name wasn't specified then set it to the address /Fredrik
	if(inName.IsEmpty())
		name = inAddress;
	else
		name = inName;
	data = NULL;
}

TAddress::TAddress(CString inAddress, CString inName, LPVOID inData)
{
	address = inAddress;
	// If the name wasn't specified then set it to the address /Fredrik
	if(inName.IsEmpty())
		name = inAddress;
	else
		name = inName;
	data = inData;
}

TAddress::~TAddress()
{

}

const CString & TAddress::GetAddress() const
{
	return address;
}

const CString TAddress::GetName()  const
{
	return DecodeMIMEHeader(name);
}

TAddress::TAddress()
{
// This should probably be left empty.
}

TAddressList::TAddressList()
{
	//Empty!
}

TAddressList::TAddressList(TAddressList &old)
{
	//Copy constructor

	POSITION pos = old.GetHeadPosition();
	TAddress *adr;

	while (pos != NULL)
	{
		adr = old.GetNext(pos);
		AddTail(new TAddress(*adr));
	}
}