// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// $Header: /Hermes GUI/TCodeManager.cpp 31    97-12-09 21:15 Fcl $
// $Log: /Hermes GUI/TCodeManager.cpp $
//
//31    97-12-09 21:15 Fcl
//Fixed misc. bugs in the TIO
//
//30    97-12-07 13:56 Magnus
//Moved Encode to MIMEEncoder
//
//29    97-12-07 12:07 Magnus
//Changed 7bit to 8bit
//
//28    97-12-03 0:22 Magnus
//XMailer-field added.
//
//27    97-12-02 22:57 Magnus
//Now encodes letter with Mime++
//
//26    97-11-29 21:30 Magnus
//Encode implemented.
//
//25    11/28/97 8:02p Andreas
//ExtractTOAndCC works
//
//24    97-11-27 20:54 Magnus
//Decoding of From-field works. Compiles
//
//23    97-11-27 14:25 Magnus
//Now it compiles, To and cc not finished yet
//
//22    11/27/97 12:59p Andreas
//Not compiling
//
//21    97-11-26 13:04 Peblin
//fixed precompiled headers
//
//20    97-11-25 20:58 Fcl
//Changed the decoding of the header
//
//19    11/24/97 6:06p Andreas
//Fixed some bugs. Testversion1
//
//18    97-11-24 13:24 Peblin
//Commented out parts of code that made TIO::SaveLetter crash.
//
//17    97-11-24 13:00 Peblin
//
//16    11/23/97 7:58p Andreas
//Function ExtractToAndCc almost finished.
//
//15    97-11-23 14:57 Peblin
//Fixed numerous bugs in FindString() and getblablabla
//
//14    97-11-23 13:27 Peblin
//Added CSocket support
//
//13    97-11-22 1:03 Magnus
//Function ExtractToAndCc added. The function does not work properly yet,
//but compiles.
//
//12    11/18/97 20:53 Magnus
//Implemented function FindString.
//
//11    97-11-15 21:40 Fcl
//First tested version. Is able to save and load folders with no letters
//inside
//
//10    11/15/97 19:49 Magnus
//Some functionality implemented. Does not compile.
//
//9     11/14/97 18:16 Magnus
//Added a TMIMEDecoder to decoder list in constructor
//
//8     11/08/97 17:52 Magnus
//Undo returntype changes in EncodeLetter.
//
//7     11/08/97 17:11 Magnus
//Changed returntype in EncodeLetter from CString& to TRawData&
//
//6     97-11-07 16:50 Peblin
//Changed the TCodeManager::DecodeHeader to reflect the changes in the
//THeader constructor.
//
//5     97-11-06 21:59 Fcl
//Added Header and Log statements at the top of each file

// TCodeManager.cpp: implementation of the TCodeManager class.
//
//////////////////////////////////////////////////////////////////////

#include <stdafx.h>
#include "TCodeManager.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////



CString& TCodeManager::DecodeLetter(TRawData& rawData)
{

	// Sends the rawdata to the first decoder in the clist decoders.
	// If you REALLY want to add a new decoder you will have
	// to add it to the clist decoders.
	return decoders->GetHead()->Decode(rawData);
}


THeader& TCodeManager::DecodeHeader(TRawData& rawData)
{
	int i = 0, bracketOffset = 0;
	CString blablabla;
	CString fromString;
	CString toString;
	CString ccString;
	CString subject;
	CString date;
	TAddressList* toList;
	TAddressList* ccList;
	TAddress* fromAddress;
		
	// Extract the entire header information
	blablabla = GetBlaBlaBla(rawData);
	
	// Extract "From"
	fromString = FindString("\nFrom:", blablabla);
	fromAddress = GetAddressFromString(fromString);
	
	// Extract "To"
	toString = FindString("\nTo:", blablabla);
	toList = ExtractToAndCc(toString);	

	// Extract "CC"
	ccString = FindString("\nCc:", blablabla);
	if (ccString == "")
		ccList = new TAddressList;
	else	
		ccList = ExtractToAndCc(ccString);


	// Extract "Subject"
	subject = FindString("\nSubject:", blablabla);

	// Extract "Date"
	date = FindString("\nDate:", blablabla);
	
// DELETE?????????????????????
//	delete &blablabla;

	return *(new THeader(
		*(toList),
		*(fromAddress),
		*(ccList),
		subject,date,0));

// There must be at least one TO: field in each letter.
// Temporarly added by Fredrik:

	//TAddressList* tolist = new TAddressList;

	//tolist->AddTail(new TAddress(CString("nisse@hult.se"),  CString("Nisse hult")));

//end of temporary code:
//	return *(new THeader(
//		*tolist,
//		*(fromAddress),
//		*(new TAddressList),
//		subject,date,0));

}



CString & TCodeManager::GetBlaBlaBla(TRawData& rawData)
{
	// Get char* from TRawData
// STRANGE!	char* text = new char (*rawData.GetMem());
	char* text = rawData.GetMem();
	char* dest; 
	int blablablaLength;
	CString* blablabla;

	// char *strncpy( char *strDest, const char *strSource, size_t count );
	// Copies the  first "count" part of "text" to "dest"

	blablablaLength = strlen(text) - strlen(strstr(text, "\n\n"));
	dest = new char[blablablaLength];

	strncpy(dest, text, blablablaLength);

	// Create new Cstring from char* (dest)
	blablabla = new CString(dest);

	// Clean up
	delete dest;

	return *blablabla;

}



CString& TCodeManager::EncodeLetter(CString& text, THeader& header)
{
	// Sends the text and header to the first encoder in the clist encoders.
	// If you REALLY want to add a new encoder you will have
	// to add it to the clist encoders.
	return encoders->GetHead()->Encode(text, header);
}




char* TCodeManager::GetAttachment(TAttachment& attachment, TRawData& rawData)
{
	// Minimal ambition level
	return "";
}



TCodeManager::TCodeManager()
{
	TMIMEDecoder* mimeDecoder;
	TMIMEEncoder* mimeEncoder;
	// Add one MIMEDecoder and one MIMEencoder to the lists
	mimeDecoder = new TMIMEDecoder;
	mimeEncoder = new TMIMEEncoder;
	decoders = new TDecoderList; 
	encoders = new TEncoderList; 
	decoders->AddTail(mimeDecoder);
	encoders->AddTail(mimeEncoder);
}



TCodeManager::~TCodeManager()
{
	TDecoder* d;
	TEncoder* e;
	POSITION pos;

	// Remove decoders in list
	pos = decoders->GetHeadPosition();
	while(!(pos == NULL)) 
	{
		d = decoders->GetNext(pos);
		delete d;
	}
	// Clear the decoder list
	decoders->RemoveAll();

	// Remove encoders in list
	pos = encoders->GetHeadPosition();
	while(!(pos == NULL)) 
	{
		e = encoders->GetNext(pos);
		delete e;
	}
	// Clear the encoder list
	encoders->RemoveAll();

	delete decoders;
	delete encoders;
}



// Function finds a string and returns the information 
// (even if separated by commas or semicolons)
CString & TCodeManager::FindString(CString keyWord, CString & inString)
{
	int i = 0,start;
	CString* dataString;

	dataString = new CString();

	// The returnstring starts AFTER the keyword + 1 (space)
	// Note: The keyword includes ":"
	start = inString.Find(keyWord);
	if(start == -1)
	{
		return *(new CString(""));
	}
	start += keyWord.GetLength() + 1; //Space?????

	while (!
		    (
			  (inString[start + i] == '\n') && 
		       !(
			     (inString[start + i +1] == ' ')  || 
			     (inString[start + i + 1] == '\t')
			    )
			 )
		  )
	{
		// Copy character from inString to dataString
		*dataString += inString[start + i];

		i++;
	}

	return *dataString;
}



TAddressList* TCodeManager::ExtractToAndCc(CString inString)

{
	bool comma = false;
	CString name;
	CString addressString;
	TAddressList* addressList;
	TAddress* inAddress;
	int i =0, commaOffset=0, inStringLength;

	addressList = new TAddressList;

	while (!(inString == CString(""))) // NULL????????????????????
	{
		inStringLength = inString.GetLength(); 
			
		// Find offset for seperating comma
		//	while (((i + 1) < inStringLength) && (inString[i] != ','))
		while ((i < inStringLength) && (!comma))
		{
			if (inString[i] == ',')
			{
				comma = true;
			}
			else
			{
				if (inString[i] == '"')
				{
					i++;
					while (inString[i] != '"')
						i++;
				}
				
				if (inString[i] == '(')
				{
					i++;
					while (inString[i] != ')') 
						i++;
				}
			
				i++;
			}
		}
	
	//	if ((i + 1) < inStringLength)
	//		i++;

		commaOffset = i;

		// Copies the leftmost part of inString
		addressString = inString.Left(commaOffset);
		
		// Extract nickname and address -> addressify
		inAddress = GetAddressFromString(addressString);

		// Add the address to the list
		addressList->AddTail(inAddress);	
		
		// Copies the rightmost psrt of inString
		inString = inString.Right(inString.GetLength() - (commaOffset + 1));
	}

	return addressList;
}



// This function removes all CRLF, HTAB, " and Space from inString 
void TCodeManager::FixNameString(CString & inString)
{
	CString temp;
	int i=0, inStringLength;
	
	inStringLength = inString.GetLength();
	if (inStringLength != 0)
	{
		// Skip stupid characters from behind
		while (inStringLength > 0)
			if((inString[inStringLength - 1] == '\n')
				|| (inString[inStringLength - 1] == '\r')
				|| (inString[inStringLength - 1] == '\t')
				|| (inString[inStringLength - 1] == ' ')
				|| (inString[inStringLength - 1] == '"'))
			{		
				inStringLength--;
			}
			else
				break;			// NICE NICE !! - Courtesy Fredrik
		
		// Skip stupid characters from start
		while ((i < inStringLength)
			&&((inString[i] == '\n')
				|| (inString[i] == '\r')
				|| (inString[i] == '\t')
				|| (inString[i] == ' ')
				|| (inString[i] == '"')))
		{		
			i++;
		}
		
		while (i < inStringLength) 
		{
			if (!((inString[i] == '\n')
				|| (inString[i] == '\r')
				|| (inString[i] == '\t')))
				temp += inString[i];
			i++;
		}
	}

	inString = temp;
}
	

// This function removes all CRLF, HTAB, <, >,  and Space from inString
void TCodeManager::FixAddressString(CString & inString)
{
	CString temp;
	int i=0, inStringLength;
	
	inStringLength = inString.GetLength();
	
	// Skip all stupid characters
	while (i < inStringLength) 
	{
		if (!((inString[i] == '\n')
			|| (inString[i] == '\r')
			|| (inString[i] == '\t')
			|| (inString[i] == ' ')
			|| (inString[i] == '<')
			|| (inString[i] == '>')))
			temp += inString[i];
		i++;
	}
	inString = temp;
}



TAddress* TCodeManager::GetAddressFromString(CString inString)
{
	int i = 0, bracketOffset, inStringLength;
	CString nameString, addressString;
	TAddress* address;

	inStringLength = inString.GetLength(); 
	bracketOffset = inString.Find('<');
	
	if (bracketOffset != -1)
	// Read nickname
	{
		// Read the nickname part
		while (i < bracketOffset)
		{
			nameString += inString[i];
			i++;
		}
		
		// Skip all stupid characters
		FixNameString(nameString);				
	}

	//Read address
	while (i < inStringLength)
	{
		addressString += inString[i];
		i++;
	}

	//Skip all stupid characters
	FixAddressString(addressString);
		
	// Create a new TAddress
	address = new TAddress(addressString, nameString);		
	
	return address;
}
