// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// $Header: /Hermes GUI/TCodeManager.h 22    97-12-07 13:57 Magnus $
// $Log: /Hermes GUI/TCodeManager.h $
//
//22    97-12-07 13:57 Magnus
//Moved Encode to MIMEDecoder
//
//21    11/28/97 8:02p Andreas
//ExtractTOAndCC works
//
//20    97-11-27 20:54 Magnus
//Decoding of From-field works. Compiles
//
//19    97-11-27 14:26 Magnus
//Compiles. To and cc not finished yet
//
//18    11/27/97 12:59p Andreas
//Not compiling
//
//17    97-11-26 13:04 Peblin
//fixed precompiled headers
//
//16    11/23/97 7:59p Andreas
//Function ExtractToAndCc almost finished.
//
//15    97-11-23 13:27 Peblin
//Added CSocket support
//
//14    97-11-22 1:04 Magnus
//Function ExtractToAndCc added.
//
//13    11/18/97 20:53 Magnus
//Implemented function FindString
//
//12    11/14/97 18:16 Magnus
//Added a TMIMEDecoder to decoder list in constructor
//
//11    97-08-06 19:23 Fcl
//Added forward.h
//
//10    11/08/97 17:52 Magnus
//Undo returntype changes in EncodeLetter.
//
//9     11/08/97 17:07 Magnus
//Changed returntype of EncodeLetter from CString& to TRawData&
//
//8     97-11-07 16:47 Peblin
//Commented out a couple of errors. These need to be fixed!
//
//7     97-11-06 21:59 Fcl
//Added Header and Log statements at the top of each file

// TCodeManager.h: interface for the TCodeManager class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TCODEMANAGER_H__92ECFBD9_54F8_11D1_8835_0040051E6644__INCLUDED_)
#define AFX_TCODEMANAGER_H__92ECFBD9_54F8_11D1_8835_0040051E6644__INCLUDED_

#include "forward.h"
#include "TAttachment.h"
#include "TRawData.h"
#include "THeader.h"
#include "TDecoder.h"
#include "TEncoder.h"
#include "TAddress.h"	// Added by ClassView
#include "TEncoder.h"
#include <string.h>
#include "TMIMEDecoder.h"
#include "TMIMEEncoder.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000


class TCodeManager  
{
public:
	~TCodeManager();
	TCodeManager();
	char *GetAttachment(TAttachment& attachment, TRawData& rawData);
	CString& EncodeLetter(CString& text, THeader& header);
	CString& GetBlaBlaBla(TRawData& rawData);
	THeader& DecodeHeader(TRawData& rawData);
	CString& DecodeLetter(TRawData& rawData);

private:
	TAddress* GetAddressFromString(CString inString);
	void FixAddressString(CString& inString);
	void FixNameString(CString& inString);
	TAddressList* ExtractToAndCc(CString inString);
	CString & FindString(CString keyWord, CString& inString);
	TDecoderList* decoders; 
	TEncoderList* encoders; 
};

#endif // !defined(AFX_TCODEMANAGER_H__92ECFBD9_54F8_11D1_8835_0040051E6644__INCLUDED_)
