// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// $Header: /Hermes GUI/TFolder.h 24    97-12-05 17:09 Fcl $
// $Log: /Hermes GUI/TFolder.h $
//
//24    97-12-05 17:09 Fcl
//Fixed the startup - can now handle empty mail folder or corrupt one.
//
//23    97-11-26 13:04 Peblin
//fixed precompiled headers
//
//22    97-11-24 9:45 Peblin
//DESIGN CHANGE:
//Made LoadLetters() public to be accessible from TIO.
//
//21    97-11-23 13:27 Peblin
//Added CSocket support
//
//20    97-11-15 21:40 Fcl
//First tested version. Is able to save and load folders with no letters
//inside
//
//19    97-11-15 13:19 Bjorn
//Added GetFLags() for TIO
//
//18    97-11-15 12:35 Bjorn
//Added SetID (for TIO class)
//
//17    97-11-14 11:20 Fcl
//Changed TMMap::GetPointer to return a constant pointer and moved
//postOffice decl.
//
//16    11/13/97 17:00 Magnus
//All fuctionality in TFolder implemented.
//
//15    97-11-11 20:36 Peblin
//Made RemoveLetter public.
//
//14    97-11-11 20:23 Peblin
//Added function GetID() to access the folderID variable
//
//13    97-08-06 19:24 Fcl
//Added forward.h
//
//12    97-11-07 8:58 Peblin
//Cosmetic changes
//
//11    97-11-07 8:21 Peblin
//
//10    97-11-06 21:59 Fcl
//Added Header and Log statements at the top of each file

// TFolder.h: interface for the TFolder class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TFOLDER_H__92ECFBD7_54F8_11D1_8835_0040051E6644__INCLUDED_)
#define AFX_TFOLDER_H__92ECFBD7_54F8_11D1_8835_0040051E6644__INCLUDED_

#include "forward.h"

#include "TLetter.h"
#include "TPostOffice.h"
#include "TGenericException.h"


#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

const int NO_ID = -1;

class TFolder;
class TFolderList : public CList<TFolder*,TFolder*> {};


extern TFolder& NO_FOLDER;

class TFolder  
{
public:
	int GetFlags();
	void SetID(int ID);
	CString& GetName();
	bool GetFlag(int inFlag);
	void ClearFlags(int inFlags);
	void SetFlags(int inFlags);
	enum folderflags {changed=0x08, lettersloaded=0x40};
	
	TFolder();
	TFolder(CString& name, int id = NO_ID);
	void RemoveSubFolder(TFolder& folder);
	TFolderList& GetSubFolders();
	TFolder& GetParent();
	void Delete();
	TLetterList& GetLetters();
	void AddSubFolder(TFolder& folder);
	void AddLetter(TLetter &letter);
	void Rename(CString& name);
	int GetID();
	void RemoveLetter(TLetter& letter);
	virtual ~TFolder();
	void Save();
	void LoadLetters();
private:
	int flags;
	CString name; 
	TLetterList* letters;
	TFolderList* folders; 
	TFolder* parent;
	int folderID;
	void ChangeParent(TFolder& parent);


};


#endif // !defined(AFX_TFOLDER_H__92ECFBD7_54F8_11D1_8835_0040051E6644__INCLUDED_)
