// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// $Header: /Hermes GUI/THeader.h 22    97-11-30 18:45 Fcl $
// $Log: /Hermes GUI/THeader.h $
//
//22    97-11-30 18:45 Fcl
//Added decoding of the header fields via an DecodeMIMEHeader function
//
//21    97-11-30 11:11 Fcl
//Fixat datumhantering i THeader
//
//20    97-11-28 23:38 Fcl
//Added cut&paste support in header window
//Added copy constructors when needed,
//
//19    97-11-28 14:26 Fcl
//
//18    97-11-26 17:20 Fcl
//Added LetterView
//
//17    97-11-26 13:04 Peblin
//fixed precompiled headers
//
//16    97-11-24 14:25 Peblin
//Fixed reference declaration of date in constructor
//
//15    11/23/97 8:00p Andreas
//Added the date-field in THeader.
//
//14    97-11-23 13:27 Peblin
//Added CSocket support
//
//13    97-11-15 13:12 Bjorn
//Added GetFLags() for TIO
//
//12    97-11-14 19:31 Fcl
//Check in to be able to move the repository to mandel.
//
//11    97-08-06 19:24 Fcl
//Added forward.h
//
//10    97-11-07 16:49 Peblin
//
//9     97-11-07 11:26 Peblin
//
//8     97-11-07 10:41 Peblin
//All functionality implemented. Compiles
//
//7     97-11-06 21:59 Fcl
//Added Header and Log statements at the top of each file

// THeader.h: interface for the THeader class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_THEADER_H__92ECFBD1_54F8_11D1_8835_0040051E6644__INCLUDED_)
#define AFX_THEADER_H__92ECFBD1_54F8_11D1_8835_0040051E6644__INCLUDED_

#include "forward.h"
#include "TAddress.h"


#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

class THeaderList : public CList<THeader*,THeader*> {};

CString DecodeMIMEHeader(CString str);
// Decode the =?skldsasljdk?= field!

class THeader  
{
public:
	CString & GetDate();
	CTime GetCTime();
	int GetFlags();
	enum headerflags {read = 0x01, sent=0x02, replied=0x04, changed=0x08,
		external=0x10, locked=0x20};
	THeader(TAddressList & inTo, TAddress & inFrom, TAddressList & inCc,
				 CString & inSubject, CTime& inDate, int inFlags);
	THeader(TAddressList &inTo, TAddress &inFrom, TAddressList &inCc, CString &inSubject, CString& inDate, int inFlags);
	THeader(THeader& old);
	CString GetSubject();			// Not compliant with design
	TAddress & GetFrom();
	TAddressList& GetCC();
	TAddressList& GetTo();
	bool GetFlag(int inFlag);
	void ClearFlags(int inFlags);
	void SetFlags(int inFlags);
	virtual ~THeader();

private:
	int flags;
	CString subject;
	CTime date;
	CString datestr;
	TAddress from;
	TAddressList* cc;
	TAddressList* to;
};


#endif // !defined(AFX_THEADER_H__92ECFBD1_54F8_11D1_8835_0040051E6644__INCLUDED_)
