// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// $Header: /Hermes GUI/TIO.cpp 33    97-12-10 20:37 Fcl $
// $Log: /Hermes GUI/TIO.cpp $
//
//33    97-12-10 20:37 Fcl
//
//32    97-12-09 21:15 Fcl
//Fixed misc. bugs in the TIO
//
//31    97-12-07 12:17 Fcl
//Misc files checkin - the folder system now saves and it is possible to
//send letters
//
//New checkbox added in preferences 
//
//30    97-12-07 0:43 Magnus
//Now LoadPreferences works with space in the fields.
//
//29    97-12-06 22:11 Fcl
//
//28    12/06/97 6:13p Andreas
//Added some more to load/save preference.
//
//27    97-12-06 17:07 Fcl
//
//26    12/06/97 11:50a Andreas
//Added some in LoadPrefs and SavePrefs
//
//25    97-12-06 0:22 Fcl
//Fixed the startup - can now handle empty mail folder or corrupt one.
//
//24    12/05/97 6:37p Andreas
//Added SavePreference and LoadPreference
//
//23    97-12-02 23:42 Peblin
//Commented out sections of LoadAddressBook (which is unneccesary
//nowadays).
//
//22    97-11-29 16:01 Fcl
//Added the possibility to remove several letters at a time.
//Some more bug fixes
//
//21    97-11-29 13:11 Fcl
//Added rename possibility
//
//20    97-11-29 11:23 Peblin
//Changed error handling in LoadAddressBook. A bug still exists; the last
//address is read twice.
//
//19    97-11-29 1:02 Peblin
//Added and implemented LoadAddressBook and SaveAddressBook. Both works
//as they should.
//
//18    97-11-28 0:04 Fcl
//Fixed the saving of the DATE field in the letter! Please note that this
//requires that
//all old mail files are removed
//
//17    97-11-26 13:04 Peblin
//fixed precompiled headers
//
//16    97-11-25 20:58 Fcl
//Changed the decoding of the header
//
//15    97-11-25 9:51 Peblin
//Fixed bugs in TIO
//
//14    97-11-24 14:26 Peblin
//Made it work. :)
//
//13    97-11-23 20:51 Peblin
//Gets and saves letters.
//
//12    97-11-23 13:27 Peblin
//Added CSocket support
//
//11    97-11-15 21:40 Fcl
//First tested version. Is able to save and load folders with no letters
//inside
//
//10    97-11-15 13:41 Bjorn
//Added code for all functions (except saveattachment)
//
//9     97-11-14 19:31 Fcl
//Check in to be able to move the repository to mandel.
//
//8     11/13/97 16:24 Magnus
//Changed LoadHeader to LoadHeaders.
//Fixed capitals in flags.
//
//7     97-11-13 13:32 Fcl
//Check to be able to continue at magnum
//
//6     97-08-06 21:23 Fcl
//
//5     97-08-06 20:14 Fcl
//Implemented constructor and destructor
//Changed the inputarguments for constructor
//
//4     97-11-06 21:59 Fcl
//Added Header and Log statements at the top of each file

// TIO.cpp: implementation of the TIO class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TIO.h"
#include "TGenericException.h"
#include <stdlib.h>
#include <string.h>
#include <iostream.h>
#include <fstream.h>
#include <iomanip.h>
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TIO::TIO(char *mailDir)
{
	HANDLE fileHandle;
	WIN32_FIND_DATA fileData;

	//Initiate the lookuptables
	folderIDTab = new TFolderIDTab;
	letterIDTab = new TLetterIDTab;
	nextAvailID = 6;

	rootDir = new CString(mailDir);
	fileHandle = FindFirstFile(CString(mailDir)+CString("*.dat"), &fileData);

	if(fileHandle == INVALID_HANDLE_VALUE)
		return;

	char fileNumber[8];
	int number;
	nextAvailID = 0;

	//Retrieves the numeric part of the filename if its a letter or folderfile..
	strncpy(fileNumber, fileData.cFileName+1, 7);
	number = atoi(fileNumber);

	if(!number)
		EXCEPT("Error in filenameconversion");
	nextAvailID = number;
	
	//Traverse every file.dat in folder and find the maximum ID
	while(FindNextFile(fileHandle, &fileData))
	{
		strncpy(fileNumber, fileData.cFileName+1, 7);
		number = atoi(fileNumber);

		if(!number)
			EXCEPT("Error in filenameconversion");

		if(number>nextAvailID)
			nextAvailID = number;
	}
	
	FindClose(fileHandle);
	nextAvailID++;

}

TIO::~TIO()
{
	delete folderIDTab;
	delete letterIDTab;
	delete rootDir;
}

TFolder& TIO::LoadFolder(int folderID)
{
	TFolder *folder;
	int flags;

	CreateFileName(folderID, FOLDER);

	// Open the folder file
	
	TMMap map(CreateFileName(folderID, FOLDER), GENERIC_READ);

	// The file specification is:
	// int flags;
	// char name[?] + null char to indicate end of string
	// int folderIDs[?] + NO_ID to end folder list
	// int letterIDs[?] + NO_ID to end letter list

	int *memstart = (int *) map.GetPointer();

	flags = memstart[0];
	
	CString folderName(map.GetPointer() +sizeof(int));

	folder = new TFolder(folderName, folderID);

	folder->SetFlags(flags);


				// Change the starting position to skip a) the first int 
				//														b) the length of the name string
				//														c) the trailing null char
	map.SetOffset(sizeof(int) + (folder->GetName()).GetLength() + 1); 

				// The IDs are ints and memstart points to the first.
	memstart =  (int *) map.GetPointer();
	
	int i = 0; // Counts the number of folders

					// Iterate and create all subfolder object, and add them to the folder.
 	while(memstart[i] != NO_ID) 
	{
		folder->AddSubFolder(LoadFolder(memstart[i]));
		i ++;
	}
		// Clear the folder flags
	folder->ClearFlags(TFolder::lettersloaded | TFolder::changed);


		//Add the folder to the table of ID's
	(*folderIDTab)[folderID] =folder;

	map.Close();
	folder->LoadLetters();
	return *folder;
}

void TIO::LoadHeaders(TFolder & folder)
{
	TMMap *map;

	TRY_CATCH(
			map = new TMMap(CreateFileName(folder.GetID(), FOLDER), GENERIC_READ)
	);

	// The file specification is:
	// int flags;
	// char name[?] + null char to indicate end of string
	// int folderIDs[?] + NO_ID to end folder list
	// int letterIDs[?] + NO_ID to end letter list

	


				// Change the starting position to skip a) the first int 
				//														b) the length of the name string

				// The IDs are ints and memstart points to the first.

	// NOTE: The cast to char * is strange but needed to compile

	char *memstart = (char *) map->GetPointer(); 
		
	memstart +=  sizeof(int);

	while(*memstart != 0) 
	{
		memstart++;
	}
	
	memstart++; // Consume the trailing NULL-termination (Added by Per)

	int *idstart = (int *) memstart;

					// Iterate and create all subfolder object, and add them to the folder.
 	while(*idstart != NO_ID) 
	{
		idstart++;
	}
	
	idstart++; // Consume the first NO_ID (Added by Per)

	while(*idstart != NO_ID)
	{	
		TLetter *newletter = ExtractHeader(*idstart);

		(*letterIDTab)[*idstart] = newletter;
		folder.AddLetter(*newletter);
		idstart++;
	}

		//Destroy the folder file mapping.
	delete map;
}

void TIO::SaveLetter(TLetter& letter)
{
	if(letter.GetID() == NO_ID)
	{
		int newID = GetNextID();
		letter.SetID(newID);
		(*letterIDTab)[newID] = &letter;
	}
	else
	{
		//make sure that we got the data in memory
		letter.GetRawData().ReleaseFile();

		//Delete the file on disk
		if(!DeleteFile(CreateFileName(letter.GetID(), LETTER)));
			//EXCEPT("Could not remove letterfile when saving letter");
	}

	//Create the header-string:

	CString headerData;
	THeader &header = letter.GetHeader();

	//Add the first fields (use \n instead of null temorarily)

	header.GetFrom().GetAddress();
	headerData += header.GetFrom().GetAddress() +"\n";
	headerData += header.GetFrom().GetName() +"\n";
	headerData += "TO:\n";

	//Traverse the to-list
	TAddressList &toList = header.GetTo();
	TAddress *adr;
	
	POSITION pos = toList.GetHeadPosition();
	
	while(!(pos == NULL)) 
	{
		adr = toList.GetNext(pos);
		headerData += adr->GetAddress() + "\n";
		headerData += adr->GetName()+ "\n";
	}
	
	// Special case to handle the case where no To: was specified
	if(toList.IsEmpty())
		headerData += "no@unknown.com\nNoname\n";

	headerData += "CC:\n";

	//Traverse the cc-list
	TAddressList &ccList = header.GetCC();
	
	pos = ccList.GetHeadPosition();
	
	while(!(pos == NULL)) 
	{
		adr = ccList.GetNext(pos);
		headerData += adr->GetAddress() + "\n";
		headerData += adr->GetName()+ "\n";
	}

	headerData += "SUBJECT:\n";
	headerData += header.GetSubject() + "\n";

	headerData += "DATE:\n";
	headerData += header.GetDate();

	// the 2 ints for raw-data-position and flags, header, 1 for trailing null-char
	int length = 2*sizeof(int) + headerData.GetLength() + 1;
	
	//Create a new file that maps the new data
	TMMap* mm = new TMMap(
		CreateFileName(letter.GetID(), LETTER), 
		GENERIC_READ | GENERIC_WRITE,
		length + letter.GetRawData().GetSize());

	//insert the first 2 integers (rawdatapos and flags)
	int *mmint = (int *)mm->GetPointer();
	mmint[0] = letter.GetRawData().GetSize();
	mmint[1] = letter.GetHeader().GetFlags();

	//Replace all the occurance of '\n' to null and copy the data from memory to disk
	for(int i=0; i < (headerData.GetLength()); i++)
	{
		if(headerData[i] == '\n')
			(*mm)[i+2*sizeof(int)] = 0;
		else
			(*mm)[i+2*sizeof(int)] = headerData[i];
	}

	//Copy the rawdata to disk
	memcpy(mm->GetPointer()+length, letter.GetRawData().GetMem(), letter.GetRawData().GetSize());

	//Use this to create a new rawdata-object
	mm->SetOffset(length);

	letter.GetRawData().SetMMap(*mm);	
}

void TIO::SaveFolder(TFolder & folder)
{
	if(folder.GetID() == NO_ID)
	{
		int newID = GetNextID();
		folder.SetID(newID);
		(*folderIDTab)[newID] = &folder;
	}
	else
	{
		//Delete the file on disk
		//if(!DeleteFile(CreateFileName(folder.GetID(), FOLDER)))
			//This message shouldn't be shown
			//AfxMessageBox("Could not remove folderfile when saving letter\nPossibly a corrupted database?");
	}

	//Calculate the filesize
	int size = sizeof(folder.GetFlags()) 
		+ folder.GetName().GetLength()+1
		+ folder.GetSubFolders().GetCount()*sizeof(int)
		+ sizeof(NO_ID)
		+ folder.GetLetters().GetCount()*sizeof(int)
		+ sizeof(NO_ID);

	//Create the file
	TMMap mm(CreateFileName(folder.GetID(), FOLDER), 
		GENERIC_READ | GENERIC_WRITE, 
		size);

	int *mmint = (int *)mm.GetPointer();
	int fPos=0;
	int i=0;
	
	//Write the flags
	mmint[fPos] = folder.GetFlags();

	//Write the name
	strcpy(mm.GetPointer() + sizeof(folder.GetFlags()), folder.GetName());

	fPos += folder.GetName().GetLength()+1 + sizeof(folder.GetFlags());

	TFolderList &folderList = folder.GetSubFolders();
	POSITION pos = folderList.GetHeadPosition();

	//Write the folderIDs
	mmint = (int *)(mm.GetPointer() + fPos);

	while(!(pos == NULL)) 
	{
		mmint[i] = (folderList.GetNext(pos))->GetID();
		i++;
	}

	mmint[i] = NO_ID;
	i++;

	//Write the letterIDs
	TLetterList &letterList = folder.GetLetters();
	pos = letterList.GetHeadPosition();

	while(!(pos == NULL)) 
	{
		mmint[i] = (letterList.GetNext(pos))->GetID();
		i++;
	}

	mmint[i] = NO_ID;
		
}

void TIO::DeleteLetter(TLetter & letter)
{
	if(letter.GetID() != NO_ID)
	{
		letter.GetRawData().ReleaseFile();
		letterIDTab->RemoveKey(letter.GetID());

		if(!DeleteFile(CreateFileName(letter.GetID(), LETTER)))
			EXCEPT("There was no file to delete");

		letter.SetID(NO_ID);
	}
}

void TIO::DeleteFolder(TFolder & folder)
{
	if(folder.GetSubFolders().IsEmpty() && folder.GetLetters().IsEmpty())
	{
		folderIDTab->RemoveKey(folder.GetID());

		if(!DeleteFile(CreateFileName(folder.GetID(), FOLDER)))
			EXCEPT("There was no file to delete");

		folder.SetID(NO_ID);
	}
	else
		EXCEPT("Trying to delete not empty folder");
}

void TIO::SaveAttachment(TAttachment & attachment, CString & fileName)
{

}

TFolder& TIO::FindFolder(int id)
{
	TFolder *folder;

	if(!folderIDTab->Lookup(id, folder))
		EXCEPT("No folder was found in lookuptable");

	return *folder;
}

TLetter& TIO::FindLetter(int id)
{
	TLetter *letter;

	if(!letterIDTab->Lookup(id, letter))
		EXCEPT("No letter was found in lookuptable");

	return *letter;
}

TLetter* TIO::ExtractHeader(int ID)
{
	TMMap *map;

	TRY_CATCH(
			map = new TMMap(CreateFileName(ID, LETTER), GENERIC_READ)
	);
	
	int* memstart = (int *)map->GetPointer();
	int rawdatastart = *memstart;
	int flags = *memstart +1;

	int pos = sizeof(int)*2;

	TAddressList* toList = new TAddressList;
	TAddressList* ccList = new TAddressList;

	//Retrieve the different strings (and increase the file-pos, including the null-char)
	
	//From-field:
	CString fromMail(map->GetPointer() + pos);
	pos += fromMail.GetLength() + 1;

	CString fromName(map->GetPointer() + pos);
	pos += fromName.GetLength() + 1;

	TAddress* from= new TAddress(fromMail, fromName);

	//To-Tag:
	CString toTag(map->GetPointer() + pos);
	pos += toTag.GetLength() + 1;

	if(strcmp(toTag,"TO:")) // Cant be !strcmp, look at the return value of strcmp! /Per
		EXCEPT("To field not found in letter");

	//Read the first to-fields
	CString nextToMail(map->GetPointer() + pos);
	pos += nextToMail.GetLength() + 1;

	CString nextToName(map->GetPointer() + pos);
	pos += nextToName.GetLength() + 1;

	//Insert the first addressee in the list
	toList->AddTail(new TAddress(nextToMail, nextToName));
	
	//Perhaps next to-mail, perhaps CC:
	nextToMail = CString(map->GetPointer() + pos);
	pos += nextToMail.GetLength() + 1;

	while(strcmp(nextToMail, "CC:"))
	{
		nextToName = CString(map->GetPointer() + pos);
		pos += nextToName.GetLength() + 1;

		//Insert next addressee in list
		toList->AddTail(new TAddress(nextToMail, nextToName));

		nextToMail = CString(map->GetPointer() + pos);
		pos += nextToMail.GetLength() + 1;
	}

	//---------
	//Okey, now we've found CC: in the file, get more address

	//Perhaps next CCMmail, perhaps Subject
	CString nextCCMail(map->GetPointer() + pos);
	pos += nextCCMail.GetLength() + 1;

	while(strcmp(nextCCMail, "SUBJECT:"))
	{
		CString nextCCName(map->GetPointer() + pos);
		pos += nextCCName.GetLength() + 1;

		//Insert next CC-addressee in list
		ccList->AddTail(new TAddress(nextCCMail, nextCCName));

		nextCCMail = CString(map->GetPointer() + pos);
		pos += nextCCMail.GetLength() + 1;
	}

	//---------
	//Okey, now we've found SUBJECT: in the file, get subject
	// Allways a subject (perhaps an empty string)

	CString subject(map->GetPointer() + pos);
	pos += subject.GetLength() + 1;

	//Okey, now we've found DATE: in the file, get subject
	// Allways a subject (perhaps an empty string)
	pos += 6;
	CString date(map->GetPointer() + pos);
	pos += date.GetLength() + 1;

	//Cool we've found the rawdata
	
	//Lets point out the rawdata
	map->SetOffset(pos);

	//Return the new object
	return new TLetter(
		ID, 
		*(new THeader(*toList, *from, *ccList, subject, date, flags)), 
		*(new TRawData(map)));
}

int TIO::GetNextID()
{
	// return and increment the ID
	return nextAvailID++;
}

CString TIO::CreateFileName(int ID, type folder)
{
	char buf[10];

	//Skapa filnamnet
	sprintf(buf, "%07d", ID);	

	if(folder == FOLDER)
		return *rootDir + CString("F") + CString(buf) + CString(".DAT");
	else
		return *rootDir + CString("L") + CString(buf) + CString(".DAT");
}

TAddressBook* TIO::LoadAddressBook()
{
	const int bufsize=255;
	TAddressBook* addressBook;
	char newName[bufsize];
	char newAddr[bufsize];

	// Create infile stream
	ifstream infile(*rootDir + CString("AddressBook.bin"), ios::in | ios::nocreate);
	if(!infile)
	{
		throw "Unable to open address book.";
	}

	// Create a new address book
	addressBook = new TAddressBook;

	while(!infile.eof())
	{
		infile >> setw(bufsize) >> newName;
		infile >> setw(bufsize) >> newAddr;
		
//		addressBook->AddAddress(
//			new TAddress(CString(newName), CString(newAddr)));
	}

	return addressBook;
}

void TIO::SaveAddressBook(TAddressBook & addressBook)
{
	TAddress* addr;
	
	ofstream outfile(*rootDir + CString("AddressBook.bin"), ios::trunc);
	if(!outfile)
	{
		EXCEPT("Unable to create address book file.");
	}

	const TAddressList& al = addressBook.GetAddressList();
	
	POSITION pos = al.GetHeadPosition();
	while(!(pos==NULL))
	{
		addr = al.GetNext(pos);
		outfile << addr->GetName() << endl;
		outfile << addr->GetAddress() << endl;
	}
}




TPreference* TIO::LoadPreference()
{
	const int bufsize=255;
	TPreference* preference;
	char tempString[bufsize];
	CString userName,
		mailAddress,
		userID,
		passWord,
		popServer,
		smtpServer;
	int	checkMailTime;
	bool checkMail = false;
	bool leaveOnServer = false;
	bool onlyNewMail = false;
	int tmpCheckMail;
	int tmpLeaveOnServer;
	int tmpOnlyNewMail;
	CString temp;

	// Create infile stream
	ifstream infile(CString("Preference.bin"), ios::in | ios::nocreate);
	if(!infile)
	{
		return (new TPreference);
	}
	
	// Read from file
	// Read username
	int i=0;
	do {
		infile.get(tempString[i]);
	}while (tempString[i++] != '\n');
	// Create the CString
	userName = CString(tempString,i - 1); //i-1 to skip newline char

	// Read mailaddress
	i=0;
	do {
		infile.get(tempString[i]);
	}while (tempString[i++] != '\n');
	// Create the CString
	mailAddress = CString(tempString,i - 1);

	// Read UserID
	i=0;
	do {
		infile.get(tempString[i]);
	}while (tempString[i++] != '\n');
	// Create the CString
	userID = CString(tempString,i - 1);

	// Read password
	i=0;
	do {
		infile.get(tempString[i]);
	}while (tempString[i++] != '\n');
	// Create the CString
	passWord = CString(tempString,i - 1);

	// Read POPserver
	i=0;
	do {
		infile.get(tempString[i]);
	}while (tempString[i++] != '\n');
	// Create the CString
	popServer = CString(tempString,i - 1);

	// Read SMTPserver
	i=0;
	do {
		infile.get(tempString[i]);
	}while (tempString[i++] != '\n');
	// Create the CString
	smtpServer = CString(tempString,i - 1);

	// The rest are just int
	infile >> checkMailTime;
	infile >> tmpCheckMail;
	infile >> tmpLeaveOnServer;
	infile >> tmpOnlyNewMail;

	// Int -> Bool converter
	if (tmpCheckMail) 
		checkMail = true;

	if (tmpLeaveOnServer) 
		leaveOnServer = true;

	if (tmpOnlyNewMail) 
		onlyNewMail = true;

	// Create a new preference object
	preference = new TPreference(userName, mailAddress,
												userID, passWord,
												popServer, smtpServer, checkMailTime,
												checkMail, leaveOnServer, onlyNewMail);

	return preference;
}

void TIO::SavePreference(TPreference& preference)
{
	// Create outfile stream
	ofstream outfile(CString("Preference.bin"), ios::trunc);
	if(!outfile)
	{
		EXCEPT("Unable to create Preference file.");
	}

	// Write to file
	outfile << preference.GetUserName() << endl;
	outfile << preference.GetMailAddress() << endl;
	outfile << preference.GetUserID() << endl;
	outfile << preference.GetPassWord() << endl;
	outfile << preference.GetPOPServer() << endl;
	outfile << preference.GetSMTPServer() << endl;
	outfile << preference.GetCheckMailTime() << endl;
	outfile << preference.GetCheckMail() << endl;
	outfile << preference.GetLeaveOnServer() << endl;
	outfile << preference.GetOnlyNewMail() << endl;
}

TFolder &TIO::RecoverDatabase()
{
	TFolder *root;
	int flags;
	TMMap *map;

	// Create the base folder system.

	root = new TFolder(CString("Hermes mail"), TPostOffice::rootID);
		//Add the folder to the table of ID's
	(*folderIDTab)[TPostOffice::rootID] = root;

	TFolder * inbox = new TFolder(CString("Inbox"),TPostOffice::inBoxID);
	root->AddSubFolder(*inbox);
	(*folderIDTab)[TPostOffice::inBoxID] = inbox;

	TFolder *folder = new TFolder(CString("Outbox"),TPostOffice::outBoxID);
	root->AddSubFolder(*folder);
	(*folderIDTab)[TPostOffice::outBoxID] = folder;

	folder = new TFolder(CString("Sent mail"),TPostOffice::sentMailID);
	root->AddSubFolder(*folder);
	(*folderIDTab)[TPostOffice::sentMailID] = folder;

	folder = new TFolder(CString("Recycle bin"),TPostOffice::trashID);
	root->AddSubFolder(*folder);
	(*folderIDTab)[TPostOffice::trashID] = folder;

	//Now we have to try to recover all the letters
	HANDLE fileHandle;
	WIN32_FIND_DATA fileData;


	fileHandle = FindFirstFile(CString(*rootDir)+CString("L*.dat"), &fileData);

	if(fileHandle != INVALID_HANDLE_VALUE)
	{	
		// There are some letters to recover

		char fileNumber[8];
		int number;
		nextAvailID = 0;
		TLetter *letter;
		//Retrieves the numeric part of the filename if its a letter or folderfile..
		strncpy(fileNumber, fileData.cFileName+1, 7);
		number = atoi(fileNumber);

		if(!number)
			EXCEPT("Error in filenameconversion");
	
		//Traverse every file.dat in folder and find the maximum ID
		do 
		{
			strncpy(fileNumber, fileData.cFileName+1, 7);
			number = atoi(fileNumber);

			if(number > 0)
			{
				bool error;
				error = false;
				// Update the ID field
				if(number > nextAvailID)
					nextAvailID = number + 1;
				try
				{
					letter = ExtractHeader(number);
				}
				catch(...)
				{
					error = true;
				}
				if(!error)
				{
					inbox->AddLetter(*letter);
					inbox->SetFlags(TFolder::changed);
				}
			}
		} while(FindNextFile(fileHandle, &fileData));
	}
	FindClose(fileHandle);
	return *root;
}
