// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// $Header: /Hermes GUI/TIO.h 19    12/06/97 6:15p Andreas $
// $Log: /Hermes GUI/TIO.h $
//
//19    12/06/97 6:15p Andreas
//Added some more to load/save preference.
//
//18    97-12-06 0:22 Fcl
//Fixed the startup - can now handle empty mail folder or corrupt one.
//
//17    12/05/97 6:42p Andreas
//Added SavePreference and LoadPreference
//
//16    97-11-29 13:11 Fcl
//Added rename possibility
//
//15    97-11-29 1:02 Peblin
//Added and implemented LoadAddressBook and SaveAddressBook. Both works
//as they should.
//
//14    97-11-26 13:04 Peblin
//fixed precompiled headers
//
//13    97-11-23 13:27 Peblin
//Added CSocket support
//
//12    97-11-15 21:40 Fcl
//First tested version. Is able to save and load folders with no letters
//inside
//
//11    97-11-15 13:41 Bjorn
//Added code for all functions (except saveattachment)
//
//10    97-11-14 19:31 Fcl
//Check in to be able to move the repository to mandel.
//
//9     11/13/97 16:24 Magnus
//Changed LoadHeader to LoadHeaders.
//Fixed capitals in flags.
//
//8     97-11-13 13:32 Fcl
//Check in to be able to continue at magnum
//
//7     97-08-06 21:23 Fcl
//
//6     97-08-06 20:18 Fcl
//
//5     97-08-06 19:24 Fcl
//Added forward.h
//
//4     97-11-06 21:59 Fcl
//Added Header and Log statements at the top of each file

// TIO.h: interface for the TIO class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TIO_H__CB9DF22E_5605_11D1_AA70_00A02447DF06__INCLUDED_)
#define AFX_TIO_H__CB9DF22E_5605_11D1_AA70_00A02447DF06__INCLUDED_

#include "forward.h"
#include "TAddressBook.h"
#include "TLetter.h"
#include "TFolder.h"
#include "TAttachment.h"
#include "TPreference.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

typedef CMap<int,int, TFolder *, TFolder *> TFolderIDTab;
typedef CMap<int,int, TLetter *, TLetter *>  TLetterIDTab;

class TIO  
{
public:
	TFolder & RecoverDatabase();
	void SaveAddressBook(TAddressBook& addressBook);
	TAddressBook* LoadAddressBook();
	void SavePreference(TPreference& preference);
	TPreference* LoadPreference();
	void SaveAttachment(TAttachment& attachment, CString& fileName);
	void DeleteFolder(TFolder& folder);
	void DeleteLetter(TLetter& letter);
	void SaveFolder(TFolder& folder);
	void SaveLetter(TLetter& letter);
	void LoadHeaders(TFolder& folder);
	TFolder& LoadFolder(int folderID);
	TFolder& FindFolder(int id);
	TLetter& FindLetter(int id);
	TIO(char *mailDir);
	virtual ~TIO();

private:
	enum type{LETTER=0, FOLDER=1};
	CString CreateFileName(int ID, type folder);
	int GetNextID();
	TLetter* ExtractHeader(int ID);
	CString* rootDir;
	TFolderIDTab *folderIDTab;
	TLetterIDTab *letterIDTab;
	int nextAvailID;
	// TODO: Container for folderIDTab
};


#endif // !defined(AFX_TIO_H__CB9DF22E_5605_11D1_AA70_00A02447DF06__INCLUDED_)
