// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// $Header: /Hermes GUI/TMailBox.cpp 19    98-01-25 17:25 Peblin $
// $Log: /Hermes GUI/TMailBox.cpp $
//
//19    98-01-25 17:25 Peblin
//Commented the code
//
//18    97-12-07 12:17 Fcl
//Misc files checkin - the folder system now saves and it is possible to
//send letters
//
//New checkbox added in preferences 
//
//17    97-12-06 1:21 Fcl
//
//16    97-11-28 10:41 Fcl
//
//15    97-11-27 22:33 Fcl
//Added possibility to send mail!
//
//14    97-11-27 21:14 Fcl
//Trying to add sending of letters
//
//13    97-11-27 17:49 Fcl
//Fixed a bug with unititialized variable
//
//12    97-11-26 14:55 Peblin
//
//11    97-11-23 20:51 Peblin
//Gets and saves letters.
//
//10    97-11-23 13:27 Peblin
//Added CSocket support
//
//9     97-11-22 17:46 Peblin
//Added old log statements (Yes, I know that theyre in the wrong
//display format)
//
//8     97-11-22 17:33 Peblin
//Implemented CheckMail() and thread communication to support this.
//User: Peblin          Date: 97-11-22  Time:  17:33
//  Implemented CheckMail() and thread communication to support this.
//
//User: Peblin          Date: 97-11-20  Time:  22:58
//  Implemented PrepareToSend functionality (phew. dont try this at
//home kids.)
//(EN GRYTA KOKAD SPAGHETTI!)
//
//User: Peblin          Date: 97-11-20  Time:  17:22
//  COmpiles and WORKS
//
//User: Peblin          Date: 97-11-19  Time:  18:38
//  Uh. I have come across a BIG problem in the thread communication.
//  Need to think.
//
//User: Peblin          Date: 97-11-18  Time:   9:37
// Compiling version. TMailBox now starts and terminates nicely.
// Implemented message-handling.
//
//User: Peblin          Date: 97-11-17  Time:  23:14
//  funkar inte. Jvligt konstigt kompileringsfel.
//
//User: Peblin          Date: 97-11-17  Time:  20:56
//
//User: Peblin          Date: 97-11-17  Time:  18:21
//Created TMailBox.cpp

// TMailBox.cpp: implementation of the TMailBox class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <winuser.h>
#include "TMailBox.h"
#include "TSendModule.h"
#include "TReceiveModule.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TMailBox::TMailBox()
{
	// Initialize events
	for(int i=0; i < NUMEVENTS; i++)
	{
		events[i] = new CEvent();
	}

	// Initialize modules for server communication
	receiveModule = new TReceiveModule(postOffice.GetPreference().GetPOPServer(),
		postOffice.GetPreference().GetUserID(),
		postOffice.GetPreference().GetPassWord(),
		postOffice.GetPreference().GetLeaveOnServer(),
		postOffice.GetPreference().GetOnlyNewMail());
	sendModule = new TSendModule(postOffice.GetPreference().GetSMTPServer());

	mainThread = AfxGetThread(); // Store the current thread pointer

	// Span the mailbox thread. The new threads immediately begins to execute in the
	// TMailBox::ThreadProc procedure. The "this" argument is used as a custom this-
	// pointer in the thread procedure.
	newThread = AfxBeginThread(TMailBox::ThreadProc, this);
}

TMailBox::~TMailBox()
{
	// Signal termination to the thread.
	events[EV_TERMINATE]->SetEvent();

	// Make sure the thread has terminated.
	CSingleLock lock(&terminatedEvent);
	lock.Lock();	// Wait infinitely for termination

	// Deallocate event array.
	for(int i=0; i < NUMEVENTS; i++)
	{
		delete events[i];
	}

	// Its safe to delete the network objects since the thread
	// using them is dead and quiet.
	delete receiveModule;
	delete sendModule;
}

////////////////////////////////////////////////////////////////////
// Publicly callable functions. DO NOT CALL THESE FROM THE
// WORKER THREAD!!!!! 
////////////////////////////////////////////////////////////////////

void TMailBox::PrepareToSend()
{
	// Signal PrepareToSend to the Worker thread
	events[EV_PREPARETOSEND]->SetEvent();
}

void TMailBox::CheckMail()
{
	// Signal Checkmail to the Worker thread
	events[EV_CHECKMAIL]->SetEvent();
}

void TMailBox::msg_ListOutgoingMail()
{
	// Retreive all mail in the OutBox.
	mailList = &postOffice.ListOutgoingMail();
	// Signal that mailList can be accessed.
	// The worker thread will wait infinitely for this signal.
	outgoingMailEvent.SetEvent();
}

void TMailBox::msg_ReceiveMail()
{
	// Signal that mailList can be "filled" with incoming mail.
	postOffice.ReceiveLetters(*mailList);
}

////////////////////////////////////////////////////////////////////
// Worker thread functions. DO NOT CALL THESE FROM THE MAIN THREAD!!
////////////////////////////////////////////////////////////////////

UINT TMailBox::ThreadProc( void * t)
{
	DWORD event;
	bool terminate;
	// Construct a "this"-like pointer for use with the TMailBox object
	TMailBox* self = (TMailBox*) t;

	terminate = FALSE;
	CMultiLock lock( (CSyncObject **)self->events, NUMEVENTS, FALSE);
	while(!terminate)   // Loop until termination
	{
		event = lock.Lock(INFINITE, FALSE);	// Wait forever for any of the events
		if( (event >= WAIT_OBJECT_0) && (event <= (WAIT_OBJECT_0 + NUMEVENTS-1))) 
		{
			switch(event-WAIT_OBJECT_0)
			{
			case EV_PREPARETOSEND:
				self->th_PrepareToSend();
				break;
			case EV_CHECKMAIL:
				self->th_CheckMail();
				break;
			case EV_TERMINATE:
				terminate = true; // Shut down thread
				break;
			}
		} else 
		{
			// The variable 'event' did not belong to a valid interval
			MessageBox(NULL, "'event' out of interval", "WORKER THREAD", MB_OK);
		}
	}
	
	self->terminatedEvent.SetEvent();
	return 0;
}

void TMailBox::th_PrepareToSend()
{
 POSITION pos;
 TLetter* letter;

	// Connect to mail server. Terminate the function if unable to connect.
	if(!sendModule->Connect()) 
	{
		return;
	}

	mainThread->m_pMainWnd->PostMessage(WM_OUTGOINGMAIL);

	CSingleLock lock(&outgoingMailEvent);
	lock.Lock();	// Wait infinitely to receive outgoing mail.

	// Get the first position of the letter list.
	pos = mailList->GetHeadPosition();
	while( !(pos == NULL) )
	{
		letter = mailList->GetNext(pos);
		if(sendModule->Send(*letter))  // Send the mail
		{
			// Update flags to "sent"
			letter->GetHeader().SetFlags(THeader::sent);
		} else 
		{
			// Update flags to indicate an error
			letter->GetHeader().ClearFlags(THeader::sent || THeader::external);
		}
	}

	// Signal to main thread that maillist contains mail.
	mainThread->m_pMainWnd->PostMessage(WM_RECEIVEMAIL);

	// Close server connection
	sendModule->Close();
}

void TMailBox::th_CheckMail()
{
 TLetter* letter;
 TRawData* rawData;

	if(!receiveModule->Check())
	{
		return; // No new mail found
	}

	// When the point of execution reaches here, we know that Receive()
	// will return at least one mail.
	// Create a new list of letters
	mailList = new TLetterList;

	// Get the next mail if one exists
	while((rawData = receiveModule->Receive()) != NULL)
	{
		letter = new TLetter(*rawData);
		// Update the flags to signal incoming mail
		letter->GetHeader().SetFlags( THeader::external );
		mailList->AddTail(letter);
	}

	// Disconnect
	receiveModule->Close();

	mainThread->m_pMainWnd->PostMessage(WM_RECEIVEMAIL);
}

