// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// $Header: /Hermes GUI/TMailBox.h 11    97-12-07 12:17 Fcl $
// $Log: /Hermes GUI/TMailBox.h $
//
//11    97-12-07 12:17 Fcl
//Misc files checkin - the folder system now saves and it is possible to
//send letters
//
//New checkbox added in preferences 
//
//10    97-11-23 13:27 Peblin
//Added CSocket support
//
//9     97-11-22 17:34 Peblin
//Added version control tags

// TMailBox.h: interface for the TMailBox class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TMAILBOX_H__854778D4_5F68_11D1_8FA1_0020AFAC5A5D__INCLUDED_)
#define AFX_TMAILBOX_H__854778D4_5F68_11D1_8FA1_0020AFAC5A5D__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#include "forward.h"
#include <afxmt.h>

////////////////////////////////////////////////////////////////////
// NOTE:
//    For this class to work, message handlers MUST be implemented
//    for the messages WM_OUTGOINGMAIL and WM_RECEIVEMAIL. These
//    implementations should call the appropriate msg_* functions
//    in TMailBox. A typical AFX_MAP entry for a handler is:
//    ON_MESSAGE(WM_RECEIVEMAIL, OnReceiveMail)
//
// FUTURE:
//    It would be nice to make TMailBox inherit CCmdTarget, thus
//    enabling it to receive messages by itself. This way, all
//    functionality required could be implemented in TMailBox
//    instead of in a GUI-class. 
//    (I tred this once, but couldnt connect the message maps
//    in TMailBox to those present in the CWinAPP and CDialog
//    descendants.)
//
//    / Per
////////////////////////////////////////////////////////////////////

#define WM_OUTGOINGMAIL (WM_USER + 1)
#define WM_RECEIVEMAIL (WM_USER + 2)

class TMailBox  
{
public:
	TMailBox();
	virtual ~TMailBox();
	static UINT ThreadProc(LPVOID t);  // Static thread function.
	void PrepareToSend();
	void CheckMail();

	////////////////////////////////////////////////////////////////////
	// The msg_* functions are used as entry points for message handlers.
	// DONT CALL THESE unless you are implementing a message handler!!!
	////////////////////////////////////////////////////////////////////
	void msg_ListOutgoingMail();
	void msg_ReceiveMail();

private:
	TSendModule* sendModule;
	TReceiveModule* receiveModule;

	TLetterList* mailList;


	/////////////////////////////////////////////////////////////////////////////////
	// The th_* functions are the functions used when running in a separate thread.
	// The thread may ONLY call th_* functions, while the main thread ONLY calls the
	// public functions. THIS IS VERY IMPORTANT!
	/////////////////////////////////////////////////////////////////////////////////
	void th_CheckMail();
	void th_PrepareToSend();

	////////////////////////////////////////////////////////////////////
	// Thread pointers
	////////////////////////////////////////////////////////////////////
	CWinThread* newThread;    // Thread for network communication
	CWinThread* mainThread;   // Pointer to the main thread

	////////////////////////////////////////////////////////////////////
	// Events for communication between functions
	////////////////////////////////////////////////////////////////////
	CEvent terminatedEvent;   // Event used by the thread to signal termination.
	CEvent outgoingMailEvent; // Event used by the main thread to signal that
							  // outgoing mail has been collected in TMailBox

	////////////////////////////////////////////////////////////////////
	// Events to be handled by the main thread loop
	//
	// Three possible events in the event loop for now...
	////////////////////////////////////////////////////////////////////

#define NUMEVENTS 3

	enum Events {EV_PREPARETOSEND=0, EV_CHECKMAIL, EV_TERMINATE};
	CEvent* events[3];
};

#endif // !defined(AFX_TMAILBOX_H__854778D4_5F68_11D1_8FA1_0020AFAC5A5D__INCLUDED_)
