// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// TMIMEEncoder.cpp: implementation of the TMIMEEncoder class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TMIMEEncoder.h"
#include "mimepp/mimepp.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TMIMEEncoder::TMIMEEncoder()
{

}

TMIMEEncoder::~TMIMEEncoder()
{

}

CString& TMIMEEncoder::Encode(CString& text, THeader& header)
{
	POSITION pos;
	TAddressList* addressList;
	TAddress* address;
	CString toString, ccString;
	
	DwMessage message;

	// Get To-field as a string
	addressList = &header.GetTo();
	
	pos = addressList->GetHeadPosition();
	while(!(pos == NULL)) 
	{
		// Get next address
		address = addressList->GetNext(pos);

		// Add one name and address to letter
		toString += (address->GetName() + "<" + (address->GetAddress()) + ">");

		// If there is more addresses we have to add a comma between them.
		if (!(pos == NULL))
			toString += CString(",\n    ");
	}

	//Get the Cc-field as a string
	addressList = &header.GetCC();

	pos = addressList->GetHeadPosition();
	while(!(pos == NULL)) 
	{
		// Get next address
		address = addressList->GetNext(pos);

		// Add one name and address to letter
		ccString += (address->GetName() + "<" + (address->GetAddress()) + ">");

		// If there is more addresses we have to add a comma between them.
		if (!(pos == NULL))
			ccString += CString(",\n    ");
	}


	DwInitialize();

    // Create MIME-Version and Message-id header fields
	DwHeaders& headers = message.Headers();
    headers.MimeVersion().FromString("1.0");
    headers.MessageId().CreateDefault();

	//Set Type
	message.Headers().ContentType().SetTypeStr("text");
    
	//Set Subtype
	message.Headers().ContentType().SetSubtypeStr("Plain");

	//Set CTE
	message.Headers().ContentTransferEncoding().FromString("8bit");
	
	//Set To
	message.Headers().To().FromString(DwString(toString));
	
	//Set From
	message.Headers().From().FromString(DwString(header.GetFrom().GetName() + "<" + 
		(header.GetFrom().GetAddress()) + ">"));
	
	//Set Cc
	// If ccString emty don't add field
	if (ccString != "")
		message.Headers().Cc().FromString(DwString(ccString));
	
	//Set Subject
	message.Headers().Subject().FromString( DwString(header.GetSubject()) );
    
	// Set X-Mailer
	DwField* field;
	field = new DwField("X-Mailer", &message.Headers()); //DELETE
	field->Parse();

	DwFieldBody* fieldbody;
	fieldbody = new DwText("Hermes 1.0", field);  //DELETE
	fieldbody->Parse();
	field->SetFieldBody(fieldbody);
	message.Headers().AddField(field); 

	// Set body
	message.Body().FromString( DwString(text) );
	
	// Assemble the DwMessage
    message.Assemble();
    
	// Nr tusan ska man ta bort dem??????
	// Clean up
	// delete field;
	// delete fieldbody;

    // Return its string contents
    return *(new CString(message.AsString().c_str()));
}