// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// $Header: /Hermes GUI/TMMap.cpp 17    97-12-06 0:22 Fcl $
// $Log: /Hermes GUI/TMMap.cpp $
//
//17    97-12-06 0:22 Fcl
//Fixed the startup - can now handle empty mail folder or corrupt one.
//
//16    97-11-26 13:04 Peblin
//fixed precompiled headers
//
//15    97-11-23 13:27 Peblin
//Added CSocket support
//
//14    97-11-15 21:40 Fcl
//First tested version. Is able to save and load folders with no letters
//inside
//
//13    97-11-14 12:59 Fcl
//Changed so that GetSize cinsiders offset
//
//12    97-11-14 12:20 Fcl
//Removed the unnecessary const declaration
//
//11    97-11-14 11:20 Fcl
//Changed TMMap::GetPointer to return a constant pointer and moved
//postOffice decl.
//
//10    97-11-13 13:32 Fcl
//Check in to be able to continue at magnum
//
//9     11/12/97 10:45 Magnus
//Added function GetPointer()
//
//8     97-11-09 15:24 Peblin
//Compiles nicely. Created macro EXCEPT() which should be used instead of
//throw.
//
//7     97-11-09 12:34 Fcl
//Fixed the size parameter when using readwrite mode.
//
//6     97-11-08 21:37 Fcl
//Not yet compiling
//
//5     97-11-08 20:32 Fcl
//First compiling version
//
//4     97-11-06 21:59 Fcl
//Added Header and Log statements at the top of each file

// TMMap.cpp: implementation of the TMMap class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "TMMap.h"
#include "TGenericException.h"
#include <iostream.h>

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TMMap::TMMap(CString& inFileName, int readWrite, int inSize)
{
 int pageaccess, filemapaccess;
	size = inSize;
	offset = 0;
	fileName = inFileName;
	DWORD createnew;

	if(readWrite == GENERIC_READ) {
		pageaccess = PAGE_READONLY;
		filemapaccess = FILE_MAP_READ;
		createnew = OPEN_EXISTING;
	} 
	else 
	{
		pageaccess = PAGE_READWRITE;
		filemapaccess = FILE_MAP_WRITE;
		createnew = OPEN_ALWAYS;
	}

	try{
	hFile = CreateFile(fileName,			// open MYFILE.TXT 
                readWrite,								// open for reading 
                0,											// not shared 
                NULL,									// no security 
                createnew,                           // existing file or create new file? 
                FILE_ATTRIBUTE_NORMAL,   // normal file 
                NULL);
    }
	catch(...) {}

	if (hFile == INVALID_HANDLE_VALUE) { 
		EXCEPT("Invalid file handle");
	}


	if(!(hMap = CreateFileMapping(hFile,	 	
								NULL,						//Security
								pageaccess,				//Access right
								0,							 //High order size
								size,						 //Low order size
								NULL)))					  //Symblic name of file
		throw "CreateFileMapping error: " ;// GetLastError();

	if(!(pointer = (char *) MapViewOfFile(hMap, 
															filemapaccess, //Accessright 
															0,					//High order offset
															0,					//Low order offset
															0)))			   //Size of area to map
		throw "CreateFileMapping error: " ;//<< GetLastError();

	if(size == 0) { 
		size = GetFileSize(hFile, NULL);
	}
}

TMMap::~TMMap()
{
	Close();
}

char& TMMap::operator[](int i)
{
	//Check  boundary. 
	if((i + offset) > size) { 
		throw;
	}

	return *(pointer + i + offset);
}

void TMMap::SetOffset(int inOffset)
{
	offset = inOffset;
}

int TMMap::GetSize()
{
	return size - offset;
}

char* TMMap::GetPointer()
{
  return pointer + offset;
}

void TMMap::Close()
{
	UnmapViewOfFile(pointer);
	CloseHandle(hMap);
	CloseHandle(hFile);
}
