// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// $Header: /Hermes GUI/TPostOffice.h 16    12/06/97 6:16p Andreas $
// $Log: /Hermes GUI/TPostOffice.h $
//
//16    12/06/97 6:16p Andreas
//Added functionallity for handling preference.
//
//15    97-11-29 17:43 Peblin
//party
//
//14    97-11-29 10:53 Peblin
//Added an addressBook variable
//
//13    97-11-27 21:14 Fcl
//
//12    97-11-23 13:27 Peblin
//Added CSocket support
//
//11    97-11-15 21:40 Fcl
//First tested version. Is able to save and load folders with no letters
//inside
//
//10    97-11-14 11:20 Fcl
//Changed TMMap::GetPointer to return a constant pointer and moved
//postOffice decl.
//
//9     97-11-11 19:05 Peblin
//Removed forward declaration of TIO and added inclusion of forward.h
//
//8     97-08-06 18:50 Fcl
//Added forward decl. of TIO (why?)
//
//7     97-11-11 18:46 Peblin
//
//6     11/08/97 14:56 Magnus
//Added GetIO function. Needed for TLetter.
//
//5     97-11-06 21:59 Fcl
//Added Header and Log statements at the top of each file

// TPostOffice.h: interface for the TPostOffice class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_TPOSTOFFICE_H__92ECFBD8_54F8_11D1_8835_0040051E6644__INCLUDED_)
#define AFX_TPOSTOFFICE_H__92ECFBD8_54F8_11D1_8835_0040051E6644__INCLUDED_

#include "forward.h"
#include "TFolder.h"	// Added by ClassView
#include "TRuleManager.h"
#include "TCodeManager.h"
#include "TIO.h"
#include "TMailBox.h"
#include "TPreference.h"

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

extern TPostOffice postOffice;

class TPostOffice  
{
public:
	TPreference& GetPreference();
	TAddressBook* GetAddressBook();
	TMailBox & GetMailBox();
	TIO& GetIO();
	TCodeManager & GetCodeManager();
	TRuleManager& GetRuleManager();
	TLetterList& ListOutgoingMail();
	void ReceiveLetters(TLetterList& letters);
	void PlaceFolder(TFolder& folder, TFolder& dest);
	void PlaceLetter(TLetter& letter, TFolder& folder);
	TFolder& GetRootFolder();
	TFolder& FindFolder(int id);
	void DeleteFolder(TFolder& folder);
	void DeleteLetter(TLetter& letter);
	void Initialize();
	TPostOffice();
	virtual ~TPostOffice();
	
	enum folderIDs {rootID = 1, outBoxID, inBoxID, sentMailID, trashID};
	
private:
	TPreference* preference;
	// The following attributes were previously declared as instances,
	// not pointers. I changed it to pointers since this gives the 
	// responsibility for creating the objects to the Initialize() method.
	// Per 97-11-11 12:00
	TFolder* rootFolder;   
	TFolder* outBox;
	TFolder* inBox;
	TFolder* sentMail;
	TFolder* trash;
	TRuleManager* ruleManager;
	TCodeManager* codeManager;
	TAddressBook* addressBook;
	TIO* IO;
	TMailBox* mailBox;
	void LoadRootFolder();
};

#endif // !defined(AFX_TPOSTOFFICE_H__92ECFBD8_54F8_11D1_8835_0040051E6644__INCLUDED_)
