// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// $Header: /Hermes GUI/TReceiveModule.cpp 16    97-12-07 12:17 Fcl $
// $Log: /Hermes GUI/TReceiveModule.cpp $
//
//16    97-12-07 12:17 Fcl
//Misc files checkin - the folder system now saves and it is possible to
//send letters
//
//New checkbox added in preferences 
//
//15    97-12-05 23:13 Fcl
//The mailbox now only retrieves new messages
//Fix the bug that caused the last message to be retreived twice
//
//14    97-11-30 19:01 Fcl
//Removed the *** dialog window that show up when new mail arrived
//
//13    97-11-29 10:33 Fcl
//Fixed a bug that caused the trailing dot to be included.
//
//12    97-11-28 10:41 Fcl
//
//11    97-11-26 13:04 Peblin
//fixed precompiled headers
//
//10    97-11-23 20:51 Peblin
//Gets and saves letters.
//
//9     97-11-23 13:27 Peblin
//Added CSocket support
//
//8     97-11-23 13:11 Peblin
//Added cleanup in Check()
//
//7     97-11-22 18:41 Fcl
//Added POP3 protocal to TReceiveModule
//
//6     97-11-22 0:05 Fcl
//
//5     97-11-21 18:32 Peblin
//
//4     97-11-06 21:59 Fcl
//Added Header and Log statements at the top of each file

// TReceiveModule.cpp: implementation of the TReceiveModule class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "TReceiveModule.h"
#include "TGenericException.h"
//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TReceiveModule::TReceiveModule(CString inHostName, 
							   CString inUserName, 
							   CString inPassword,
							   bool inleaveonserver, bool inOnlyNewMail)
{
	hostName = inHostName;
	userName = inUserName;
	password = inPassword;
	leaveonserver = inleaveonserver;
	onlynewmail = inOnlyNewMail;
}

TReceiveModule::~TReceiveModule()
{

}

bool TReceiveModule::Check()
{
	CString str;
	
	m_pSocket = new CSocket;

	if (!m_pSocket->Create())
	{
		delete m_pSocket;
		m_pSocket = NULL;
		EXCEPT("Unable to create socket!??");
	}
		
	if (!m_pSocket->Connect(hostName, 110))
	{
		delete m_pSocket;
		return false;
	}

	m_pFile = new CSocketFile(m_pSocket);

	m_pReceiveArch = new CArchive(m_pFile, CArchive::load);
	m_pSendArch = new CArchive(m_pFile, CArchive::store);
	m_pReceiveArch->ReadString(str);
//	AfxMessageBox(str);

	m_pSendArch->WriteString(CString("USER ") + userName + CString("\n"));
	m_pSendArch->Flush();
	m_pReceiveArch->ReadString(str);
//	AfxMessageBox(str);
	m_pSendArch->WriteString(CString("PASS ") + password + CString("\n"));
	m_pSendArch->Flush();
	m_pReceiveArch->ReadString(str);
//	AfxMessageBox(str);
	m_pSendArch->WriteString(CString("STAT\n"));
	m_pSendArch->Flush();
	m_pReceiveArch->ReadString(str);
	
	int msgs, last;

	sscanf(str, "+OK %d", &msgs);

	if(msgs > 0)
	{
		char msgnumbuf[80];
		_itoa(msgs,msgnumbuf,10);
//		AfxMessageBox(CString("You have ") + CString(msgnumbuf) + CString(" new messages!"));

		msgids = new CList<int,int>;
		if(onlynewmail)
		{
			m_pSendArch->WriteString(CString("LAST\n"));
			m_pSendArch->Flush();
			m_pReceiveArch->ReadString(str);
			sscanf(str, "+OK %d", &last);
		}
		else
			last = 0;
		
		m_pSendArch->WriteString(CString("LIST\n"));
		m_pSendArch->Flush();

		m_pReceiveArch->ReadString(str);
//		AfxMessageBox(str);

		int id;
		do {
			m_pReceiveArch->ReadString(str);
			sscanf(str, "%d", &id);
			//Only add the new messages to list.
			if((id > last) && (str[0] != '.'))
				msgids->AddTail(id);		
		}	while(str != ".");
	
		return true;
	} else {
		Close();  // Goodbye to server and free the allocated variables.
		return false;
	}
}

TRawData* TReceiveModule::Receive()
{	
	POSITION pos = msgids->GetHeadPosition();
	char intstr[10];

	CString str, res;
	int id;

	if(msgids->IsEmpty())
		return NULL;
	else 
	{
		id = msgids->RemoveHead();

		sprintf(intstr, "%d", id);
		m_pSendArch->WriteString(CString("RETR ")+ CString(intstr) + CString("\n"));
		m_pSendArch->Flush();
		m_pReceiveArch->ReadString(str);
		res = "";
		do {
			m_pReceiveArch->ReadString(str);
//			AfxMessageBox(str);
			if(str != ".")
				res += str + "\n";
		} while(str != ".");
//		AfxMessageBox(res);

		return new TRawData(res);
	}
}

void TReceiveModule::Close()
{	
	CString str;
	m_pSendArch->WriteString(CString("QUIT\n"));
	m_pSendArch->Flush();
	m_pReceiveArch->ReadString(str);
//	AfxMessageBox(str);

	delete m_pSendArch;
	delete m_pReceiveArch;
	delete m_pFile;
	delete m_pSocket;
}
