// H E R M E S  M A I L
// Copyright 1997-98 OaS 2004
// Further info at http://www.lysator.liu.se/~fcl/hermes/

// $Header: /Hermes GUI/TSendModule.cpp 13    97-12-08 0:29 Fcl $
// $Log: /Hermes GUI/TSendModule.cpp $
//
//13    97-12-08 0:29 Fcl
//Fixed:
//
// * Hard coded parameters in SendModule
// * The application name is now Hermes mail (in CMailFrame::OnDraw());
//
//12    97-12-07 12:17 Fcl
//Misc files checkin - the folder system now saves and it is possible to
//send letters
//
//New checkbox added in preferences 
//
//11    97-11-28 10:41 Fcl
//
//10    97-11-28 0:06 Fcl
//Fixed some more sending
//
//9     97-11-26 13:04 Peblin
//fixed precompiled headers
//
//8     97-11-23 13:27 Peblin
//Added CSocket support
//
//7     97-11-22 0:05 Fcl
//
//6     97-11-20 11:36 Peblin
//Added return values for Connect() and Send()
//
//5     97-11-19 18:12 Peblin
//Changed return types of Connect and Send to "bool"
//
//4     97-11-06 21:59 Fcl
//Added Header and Log statements at the top of each file

// TSendModule.cpp: implementation of the TSendModule class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "TSendModule.h"

//#define SHOWMESSAGE(x) AfxMessageBox(x)
#define SHOWMESSAGE(x)


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

TSendModule::TSendModule(CString inHostName)
{
	hostName=inHostName;
}

TSendModule::~TSendModule()
{

}

// Return FALSE if unsuccessful
bool TSendModule::Connect()
{

	m_pSocket = new CSocket;

	if (!m_pSocket->Create())
	{
		delete m_pSocket;
		m_pSocket = NULL;
		EXCEPT("Unable to create socket!??");
	}

	if (!m_pSocket->Connect(hostName, 25))		// 25 = SMTP port number
	{
		delete m_pSocket;
		return false;
	}

	m_pFile = new CSocketFile(m_pSocket);
	CString(str);



	m_pReceiveArch = new CArchive(m_pFile, CArchive::load);
	m_pSendArch = new CArchive(m_pFile, CArchive::store);

	m_pReceiveArch->ReadString(str);
	SHOWMESSAGE(str);

	char ownhostname[200];
	if(gethostname(ownhostname, 200))
		AfxMessageBox("Could not get own hostname.");

	m_pSendArch->WriteString(CString("HELO ") + ownhostname + "\n");
	m_pSendArch->Flush();
	m_pReceiveArch->ReadString(str);
	SHOWMESSAGE(str);
	return true;
}

// Return FALSE if unsuccessful 
bool TSendModule::Send(TLetter& letter)
{	
	CString str;
	m_pSendArch->WriteString(CString("MAIL FROM:<") + 
							letter.GetHeader().GetFrom().GetAddress() 
							+">\n");
	m_pSendArch->Flush();
	m_pReceiveArch->ReadString(str);
	SHOWMESSAGE(str);
	POSITION pos = letter.GetHeader().GetTo().GetHeadPosition();
	TAddress* toadr;
	while(pos != NULL)
	{
		toadr = letter.GetHeader().GetTo().GetNext(pos);
		m_pSendArch->WriteString(CString("RCPT TO:<" )+ toadr->GetAddress() + CString(">\n"));
		m_pSendArch->Flush();
		m_pReceiveArch->ReadString(str);
		SHOWMESSAGE(str);
	}

	TAddress* ccadr;
	pos = letter.GetHeader().GetCC().GetHeadPosition();
	while(pos != NULL)
	{
		ccadr = letter.GetHeader().GetCC().GetNext(pos);
		m_pSendArch->WriteString(CString("RCPT TO:<" )+ ccadr->GetAddress() + CString(">\n"));
		m_pSendArch->Flush();
		m_pReceiveArch->ReadString(str);
		SHOWMESSAGE(str);

	}

	m_pSendArch->WriteString(CString("DATA\n"));
	m_pSendArch->Flush();
	m_pReceiveArch->ReadString(str);
	SHOWMESSAGE(str);

	m_pSendArch->Write(letter.GetRawData().GetMem(),letter.GetRawData().GetSize());
	
	m_pSendArch->WriteString(CString("\n.\n"));
	m_pSendArch->Flush();
	m_pReceiveArch->ReadString(str);
	SHOWMESSAGE(str);

	return true;
	// TODO: Add error handling!
}

void TSendModule::Close()
{
	m_pSendArch->WriteString(CString("QUIT\n"));
	m_pSendArch->Flush();
	
	CString str;
	m_pReceiveArch->ReadString(str);
	SHOWMESSAGE(str);
	delete m_pSendArch;
	delete m_pReceiveArch;
	delete m_pFile;
	delete m_pSocket;
}
